#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

const int N = 2e5 + 10;
int sz[N], par[N], centroid;
vector<int> g[N], fg[2 * N], rev_fg[2 * N];
int curn;

void find_centroid(int v, int p = 0) {
    sz[v] = 1;
    for (auto u : g[v]) {
        if (u != p) {
            find_centroid(u, v);
            sz[v] += sz[u];
        }
    }

    bool is_centroid = (curn - sz[v]) * 2 <= curn;
    for (auto u : g[v]) {
        if (u != p && sz[u] * 2 > curn) {
            is_centroid = false;
        }
    }

    if (is_centroid) {
        centroid = v;
    }
}

void dfs(int v, int p = 0) {
    par[v] = p;
    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
}

bool used[2 * N];
int color[2 * N];
vector<int> order;

void dfs_order(int v) {
    used[v] = true;
    for (auto u : fg[v]) {
        if (!used[u]) {
            dfs_order(u);
        }
    }
    order.push_back(v);
}

void paint(int v, int cl) {
    color[v] = cl;
    for (auto u : rev_fg[v]) {
        if (!color[u]) {
            paint(u, cl);
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("in/in_S.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int T;
    cin >> T;
    while (T--) {
        int n;
        cin >> n;
        curn = n;
        vector<vector<int>> kek(n + 1);
        for (int i = 1; i <= 2 * n; i++) {
            g[i] = {};
            int color;
            cin >> color;
            kek[color].push_back(i);
        }

        for (int i = 1; i <= 4 * n; i++) {
            fg[i] = {};
            rev_fg[i] = {};
            used[i] = false;
            color[i] = 0;
        }

        vector<int> other(2 * n + 1);
        for (int i = 1; i <= n; i++) {
            other[kek[i][0]] = kek[i][1];
            other[kek[i][1]] = kek[i][0];
        }

        centroid = 0;
        for (int i = 1; i < 2 * n; i++) {
            int u, v;
            cin >> u >> v;
            g[u].push_back(v);
            g[v].push_back(u);
        }

        find_centroid(1);
        assert(centroid != 0);
        //cout << centroid << '\n';

        dfs(centroid);
        for (int i = 1; i <= 2 * n; i++) {
            int j = other[i];

            fg[i].push_back(j + 2 * n);
            fg[2 * n + i].push_back(j);

            rev_fg[j + 2 * n].push_back(i);
            rev_fg[j].push_back(2 * n + i);

            if (par[i]) {
                fg[i].push_back(par[i]);
                fg[par[i] + 2 * n].push_back(i + 2 * n);

                rev_fg[par[i]].push_back(i);
                rev_fg[i + 2 * n].push_back(par[i] + 2 * n);
            }
        }

        order = {};
        for (int i = 1; i <= 4 * n; i++) {
            if (!used[i]) {
                dfs_order(i);
            }
        }

        reverse(order.begin(), order.end());

        int cc = 0;
        for (auto v : order) {
            if (!color[v]) {
                paint(v, ++cc);
            }
        }

        vector<int> answer;
        bool ok = true;
        for (int i = 1; i <= 2 * n; i++) {
            if (color[i] == color[i + 2 * n]) {
                ok = false;
                break;
            }

            if (color[i] > color[i + 2 * n]) {
                answer.push_back(i);
            }
        }

        if (!ok) {
            cout << -1 << '\n';
        } else {
            for (auto v : answer) {
                cout << v << ' ';
            }
            cout << '\n';
        }
    }
}