#include <bits/stdc++.h>

#define len(v) (int)v.size()
#define ft first
#define sc second
#define pb push_back
#define int ll

typedef long long ll;
typedef long double ld;

using namespace std;

unordered_map<int, int> d1c;
unordered_map<int, int> d2c;
unordered_map<int, int> xc;
unordered_map<int, int> yc;
set<pair<int, int>> kek;
int n;



struct Pt {
    int x;
    int y;
    int d1;
    int d2;
};

Pt per_d1_d2(int d1, int d2) {
    int x = (d1 + d2) / 2;
    int y = d2 - x;
    return {x, y, d1, d2};
}

Pt per_d1_x(int d1, int x) {
    int y = x - d1;
    int d2 = x + y;
    return {x, y, d1, d2};
}

Pt per_d1_y(int d1, int y) {
    int x = d1 + y;
    int d2 = x + y;
    return {x, y, d1, d2};
}

Pt per_d2_x(int d2, int x) {
    int y = d2 - x;
    int d1 = x - y;
    return {x, y, d1, d2};
}

Pt per_d2_y(int d2, int y) {
    int x = d2 - y;
    int d1 = x - y;
    return {x, y, d1, d2};
}

Pt per_x_y(int x, int y) {
    return {x, y, x - y, x + y};
}

bool check(Pt pt) {
    int bound = n;
    if (kek.count({pt.x, pt.y}))
        bound += 3;
    return (d1c[pt.d1] + d2c[pt.d2] + xc[pt.x] + yc[pt.y]) == bound;
}

bool check_d1_d2(int d1, int d2) {
    if ((d1 + d2) % 2 == 1)
        return false;

    return check(per_d1_d2(d1, d2));
}

bool check_d1_x(int d1, int x) {
    return check(per_d1_x(d1, x));
}

bool check_d1_y(int d1, int y) {
    return check(per_d1_y(d1, y));
}

bool check_d2_x(int d2, int x) {
    return check(per_d2_x(d2, x));
}

bool check_d2_y(int d2, int y) {
    return check(per_d2_y(d2, y));
}

bool check_x_y(int x, int y) {
    return check(per_x_y(x, y));
}


signed main() {
#ifdef LOCAL
    freopen("in/in_D.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;

    while (t--) {
        d1c = unordered_map<int, int>();
        d2c = unordered_map<int, int>();
        xc = unordered_map<int, int>();
        yc = unordered_map<int, int>();
        bool flag = false;
        Pt ans;

        cin >> n;
        for (int i = 0; i < n; i++) {
            int x, y;
            cin >> x >> y;
            d1c[x - y] += 1;
            d2c[x + y] += 1;
            xc[x] += 1;
            yc[y] += 1;
            kek.insert({x, y});
        }

        vector<pair<int, int>> d1a;
        vector<pair<int, int>> d2a;
        vector<pair<int, int>> xa;
        vector<pair<int, int>> ya;

        for (auto [d1, cnt]: d1c) {
            d1a.emplace_back(d1, cnt);
        }

        for (auto [d2, cnt]: d2c) {
            d2a.emplace_back(d2, cnt);
        }

        for (auto [x, cnt]: xc) {
            xa.emplace_back(x, cnt);
        }

        for (auto [y, cnt]: yc) {
            ya.emplace_back(y, cnt);
        }

        for (auto [d1, cnt]: d1a) {
            if (flag)
                break;

            if (cnt >= n / 4) {
                for (auto [d2, _]: d2a) {
                    if (check_d1_d2(d1, d2)) {
                        flag = true;
                        ans = per_d1_d2(d1, d2);
                        break;
                    }
                }

                for (auto [x, _]: xa) {
                    if (check_d1_x(d1, x)) {
                        flag = true;
                        ans = per_d1_x(d1, x);
                        break;
                    }
                }
//
                for (auto [y, _]: ya) {
                    if (check_d1_y(d1, y)) {
                        flag = true;
                        ans = per_d1_y(d1, y);
                        break;
                    }
                }
            }
        }

        for (auto  [d2, cnt]: d2a) {
            if (flag)
                break;
            if (cnt >= n / 4) {
                for (auto [d1, _]: d1a) {
                    if (check_d1_d2(d1, d2)) {
                        flag = true;
                        ans = per_d1_d2(d1, d2);
                        break;
                    }
                }

                for (auto [x, _]: xa) {
                    if (check_d2_x(d2, x)) {
                        flag = true;
                        ans = per_d2_x(d2, x);
                        break;
                    }
                }

                for (auto [y, _]: ya) {
                    if (check_d2_y(d2, y)) {
                        flag = true;
                        ans = per_d2_y(d2, y);
                        break;
                    }
                }
            }
        }

        for (auto [x, cnt]: xa) {
            if (flag)
                break;
            if (cnt >= n / 4) {
                for (auto [d1, _]: d1a) {
                    if (check_d1_x(d1, x)) {
                        flag = true;
                        ans = per_d1_x(d1, x);
                        break;
                    }
                }

                for (auto [d2, _]: d2a) {
                    if (check_d2_x(d2, x)) {
                        flag = true;
                        ans = per_d2_x(d2, x);
                        break;
                    }
                }

                for (auto [y, _]: ya) {
                    if (check_x_y(x, y)) {
                        flag = true;
                        ans = per_x_y(x, y);
                        break;
                    }
                }
            }
        }

        for (auto [y, cnt]: ya) {
            if (flag)
                break;
            if (cnt >= n / 4) {
                for (auto [d1, _]: d1a) {
                    if (check_d1_y(d1, y)) {
                        flag = true;
                        ans = per_d1_y(d1, y);
                        break;
                    }
                }

                for (auto [d2, _]: d2a) {
                    if (check_d2_y(d2, y)) {
                        flag = true;
                        ans = per_d2_y(d2, y);
                        break;
                    }
                }

                for (auto [x, _]: xa) {
                    if (check_x_y(x, y)) {
                        flag = true;
                        ans = per_x_y(x, y);
                        break;
                    }
                }
            }
        }

        if (flag) {
            cout << "YES" << '\n';
            cout << ans.x << " " << ans.y << '\n';
        } else {
            cout << "NO" << '\n';
        }
    }
}