// KTO PROCHITAL TOMU LUCHI DOBRA
#include <bits/stdc++.h>
#define int long long

using namespace std;

struct point {
    int x, y;
    point() {}
    point(int x, int y): x(x), y(y) {}
    point operator + (point other) {
        return point(x + other.x, y + other.y);
    }
    point operator - (point other) {
        return point(x - other.x, y - other.y);
    }
    int operator * (point other) {
        return x * other.x + y * other.y;
    }
    int operator ^ (point other) {
        return x * other.y - y * other.x;
    }
    bool operator == (point other) {
        return x == other.x && y == other.y;
    }
};

istream& operator >> (istream &in, point &p) {
    in >> p.x >> p.y;
    return in;
}

struct fenw {
    int n;
    int total;
    vector <int> f;
    fenw(int n): n(n), total(0), f(vector<int>(n, 0)) {}
    void upd(int pos, int dv) {
        total += dv;
        for (int i = pos; i < n; i += i & (-i)) {
            f[pos] += dv;
        }
    }
    int get_(int pos) {
        int ans = 0;
        for (int i = pos; i > 0; i -= i & (-i)) {
            ans += f[pos];
        }
        return ans;
    }
    int get(int pos) {
        return total - get_(pos);
    }
};

bool strict_in_segment(point x, point a, point b) {
    if (a == x || b == x) {
        return false;
    }
    if (((x - a) ^ (b - a)) != 0) {
        return false;
    }
    return ((a - x) * (b - x)) < 0;
}

int cnt_intersec(point p, point q, vector <point> pp, vector <point> qq) {
    int ans = 0;

    vector <pair <int, int>> all;
    for (int i = 0; i < pp.size(); i++) {
        all.push_back({i, 0});
    }
    for (int i = 0; i < qq.size(); i++) {
        all.push_back({i, 1});
    }
    vector <int> pos_p(pp.size());
    vector <int> pos_q(qq.size());
    fenw f(pp.size() + qq.size() + 5);
    sort(all.begin(), all.end(), [&](pair <int, int> a, pair <int, int> b) {
        point apoint = (a.second ? qq[a.first] : pp[a.first]);
        point bpoint = (b.second ? qq[b.first] : pp[b.first]);
        int v1 = (apoint - p) ^ (bpoint - p);
        if (v1 != 0) {
            return v1 > 0;
        }
        return a.second < b.second;
    });
    for (int i = 0; i < (int) all.size(); i++) {
        if (all[i].second == 0) {
            pos_p[all[i].first] = i + 1;
        } else {
            pos_q[all[i].first] = i + 1;
        }
    }
    sort(all.begin(), all.end(), [&](pair <int, int> a, pair <int, int> b) {
        point apoint = (a.second ? qq[a.first] : pp[a.first]);
        point bpoint = (b.second ? qq[b.first] : pp[b.first]);
        int v1 = (apoint - q) ^ (bpoint - q);
        if (v1 != 0) {
            return v1 > 0;
        }
        return a.second < b.second;
    });
    reverse(all.begin(), all.end());
    for (int i = 0; i < (int) all.size(); i++) {
        if (all[i].second == 0) {
            ans += f.get(pos_p[all[i].first]);
        } else {
            f.upd(pos_q[all[i].first], 1);
        }
    }
    return ans;
}

void solve() {
    point p, q;
    int n;
    cin >> p >> q;
    cin >> n;
    vector <point> p_up, q_up, p_down, q_down;
    int cnt_p = 0, cnt_q = 0;
    for (int i = 0; i < n; i++) {
        point l, r;
        cin >> l >> r;
        if (((r - l) ^ (q - p)) == 0) {
            continue;
        }
        if (strict_in_segment(p, l, r)) {
            cnt_p++;
            if (((q - p) ^ (l - p)) > 0) {
                p_up.push_back(l);
                p_down.push_back(r);
            } else {
                p_up.push_back(r);
                p_down.push_back(l);
            }
        }
        if (strict_in_segment(q, l, r)) {
            cnt_q++;
            if (((p - q) ^ (l - q)) < 0) {
                q_up.push_back(l);
                q_down.push_back(r);
            } else {
                q_up.push_back(r);
                q_down.push_back(l);
            }
        }
    }
    int ans = cnt_p * cnt_q - cnt_intersec(p, q, p_up, q_up) - cnt_intersec(q, p, q_down, p_down);
    cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("in/in_V.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}