#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int random(int l, int r) {
    return uniform_int_distribution<int>(l, r)(rng);
}

int n;
vector<vector<int>> g;
vector<int> colors;
vector<pair<int, int>> vx;
vector<bool> used;

pair<bool, bool> dfs(int v, int p) {
    bool have_to_take = false;
    for (int u : g[v]) {
        if (u == p) continue;
        auto [have_to_take1, ok] = dfs(u, v);
        have_to_take |= have_to_take1;
        if (!ok) { return {false, false}; }
    }
    int other = v ^ vx[colors[v]].first ^ vx[colors[v]].second;
    if (have_to_take || used[v]) {
        used[v] = true;
        if (used[other]) return {false, false};
        return {true, true};
    } else {
        used[other] = true;
        return {false, true};
    }
}

void solve() {
    cin >> n;
    g.assign(n * 2, {});
    colors.assign(n * 2, 0);
    vx.assign(n, {-1, -1});
    for (int i = 0; i < n * 2; ++i) {
        cin >> colors[i];
        colors[i]--;
        if (vx[colors[i]].first == -1) {
            vx[colors[i]].first = i;
        } else {
            vx[colors[i]].second = i;
        }
    }
    for (int i = 0; i < 2 * n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    used.assign(2 * n, false);
    used[vx[0].first] = true;
    if (dfs(vx[0].first, -1).second) {
        for (int i = 0; i < 2 * n; ++i) {
            if (used[i]) {
                cout << i + 1 << " ";
            }
        }
        cout << "\n";
        return;
    }

    used.assign(2 * n, false);
    used[vx[0].second] = true;
    if (dfs(vx[0].second, -1).second) {
        for (int i = 0; i < 2 * n; ++i) {
            if (used[i]) {
                cout << i + 1 << " ";
            }
        }
        cout << "\n";
        return;
    }

    cout << "-1\n";
}

signed main() {
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}