#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>

using namespace std;
using namespace __gnu_pbds;
#define all(o) o.begin(), o.end()

template<typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int random(int l, int r) {
    return uniform_int_distribution<int>(l, r)(rng);
}

int n;
vector<vector<int>> g;
vector<vector<int>> gt;
vector<vector<int>> tre;
vector<int> colors;
vector<pair<int, int>> vx;
vector<bool> visited;
vector<vector<int>> components;
vector<int> comp_no;
vector<int> neg;
vector<int> order;
vector<bool> values;

void build_graph(int v, int p) {
    for (int u : tre[v]) {
        if (u == p) continue;
        build_graph(u, v);
        g[u].push_back(v);
        g[neg[v]].push_back(neg[u]);
    }
}

void dfs1(int v) {
    visited[v] = true;
    for (int u : g[v]) {
        if (visited[u]) continue;
        dfs1(u);
    }
    order.push_back(v);
}

void dfs2(int v) {
    visited[v] = true;
    comp_no[v] = components.size();
    components.back().push_back(v);
    for (int u: gt[v]) {
        if (visited[u]) continue;
        dfs2(u);
    }
}

bool try_from(int v) {
    g.assign(n * 2, {});
    build_graph(v, -1);
    visited.assign(n * 2, false);
    order.clear();
    for (int i = 0; i < 2 * n; ++i) {
        if (!visited[i]) {
            dfs1(i);
        }
    }
    reverse(all(order));
    gt.assign(n * 2, {});
    for (int u = 0; u < 2 * n; ++u) {
        for (int w : g[u]) {
            gt[w].push_back(u);
        }
    }
    visited.assign(n * 2, false);
    components.assign(n * 2, {});
    comp_no.assign(n * 2, 0);
    for (int u : order) {
        if (!visited[u]) {
            components.emplace_back();
            dfs2(u);
        }
    }

    for (auto[w, u] : vx) {
        if (comp_no[w] == comp_no[u]) {
            return false;
        }
    }

    values.assign(2 * n, false);
    for (int i = 0; i < n; ++i) {
        auto [u, w] = vx[i];
        if (comp_no[u] > comp_no[w]) {
            values[u] = true;
        } else {
            values[w] = true;
        }
    }
    return true;
}

void solve() {
    cin >> n;
    tre.assign(n * 2, {});
    colors.assign(n * 2, 0);
    neg.assign(n * 2, 0);
    vx.assign(n, {-1, -1});
    for (int i = 0; i < n * 2; ++i) {
        cin >> colors[i];
        colors[i]--;
        if (vx[colors[i]].first == -1) {
            vx[colors[i]].first = i;
        } else {
            vx[colors[i]].second = i;
            neg[i] = vx[colors[i]].first;
            neg[vx[colors[i]].first] = i;
        }
    }
    for (int i = 0; i < 2 * n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        tre[v].push_back(u);
        tre[u].push_back(v);
    }

    if (try_from(vx[0].first) || try_from(vx[0].second)) {
        for (int i = 0; i < 2 * n; ++i) {
            if (values[i]) {
                cout << i + 1 << " ";
            }
        }
        cout << "\n";
    } else {
        cout << "-1\n";
    }
}

signed main() {
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}