#include <bits/stdc++.h>

using namespace std;

optional<vector<int>> sat(vector<vector<int>> g, vector<int> c) {
    int n = c.size() / 2;
    vector<int> cs(n);
    for (int i = 0; i < 2 * n; i++)
        cs[c[i]] += i;

    vector<int> ts;
    {
        vector<int> was(2 * n, 0);
        auto dfs = [&](int v, auto& req) -> void {
            was[v] = 1;
            for (int u : g[v]) {
                if (!was[u])
                    req(u, req);
            }
            ts.push_back(v);
        };
        for (int v = 0; v < 2 * n; v++) {
            if (!was[v])
                dfs(v, dfs);
        }
        reverse(ts.begin(), ts.end());
    }

    vector<vector<int>> ig(2 * n);
    for (int v = 0; v < 2 * n; v++) {
        for (int u : g[v])
            ig[u].push_back(v);
    }

    vector<int> cmp(2 * n, -1);
    {
        int clr = 0;
        auto paint = [&](int v, auto& req) -> void {
            cmp[v] = clr;
            for (int u : ig[v]) {
                if (cmp[u] == -1)
                    req(u, req);
            }
        };
        for (int v : ts) {
            if (cmp[v] == -1) {
                paint(v, paint);
                clr++;
            }
        }
    }

    vector<int> val(2 * n, -1);
    for (int i = 0; i < 2 * n; i++) {
        if (cmp[cs[c[i]] - i] == cmp[i]) {
            return nullopt;
        } else if (cmp[cs[c[i]] - i] > cmp[i]) {
            val[i] = 0;
        } else {
            val[i] = 1;
        }
    }
    return val;
}

bool test(int v, vector<vector<int>> g, vector<int> c) {
    int n = c.size() / 2;
    vector<int> cs(n + 1);
    for (int i = 0; i < 2 * n; i++)
        cs[c[i]] += i;

    vector<vector<int>> impl(4 * n);
    {
        vector<int> was(n + 1);
        for (int v = 0; v < 2 * n; v++) {
            if (was[c[v]]) continue;
            was[c[v]] = 1;
            int u = cs[c[v]] - v;
            impl[2 * v + 1].push_back(2 * u);
            impl[2 * u + 1].push_back(2 * v);
            impl[2 * u].push_back(2 * v + 1);
            impl[2 * v].push_back(2 * u + 1);
        }
    }

    {
        vector<int> was(2 * n);
        auto dfs = [&](int v, auto& req) -> void {
            was[v] = 1;
            for (int u : g[v]) {
                if (!was[u]) {
                    impl[2 * u + 1].push_back(2 * v + 1);
                    impl[2 * v].push_back(2 * u);
                    req(u, req);
                }
            }
        };
        dfs(v, dfs);
    }

    vector<int> c2(4 * n);
    for (int i = 0; i < 2 * n; i++)
            c2[2 * i] = c2[2 * i + 1] = i;

    auto res = sat(impl, c2);
    if (res.has_value()) {
        for (int i = 0; i < 2 * n; i++) {
            if (res.value()[2 * i + 1])
                cout << i + 1 << ' ';
        }
        cout << '\n';
        return true;
    }
    return false;
}

void solve() {
    int n;
    cin >> n;
    vector<int>c(2 * n);
    vector<vector<int>> g(2 * n);
    for (int i = 0; i < 2 * n; i++) cin >> c[i];
    for (int i = 0; i < 2 * n - 1; i++) {
        int u, v;

        cin >> u >> v;
        u--;
        v--;

        g[v].push_back(u);
        g[u].push_back(v);
    }

    bool found = false;
    for (int i = 0; i < 2 * n; i++) {
        if (c[i] == 1 && test(i, g, c)) {
            found = true;
            break;
        }
    }
    if (!found) {
        cout << "-1\n";
    }
}


int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}