#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n; cin >> n;
    vector<int> x(n), y(n);
    for (int i = 0; i < n; i++)
        cin >> x[i] >> y[i];

    function<int(int, int)> line[] = {
        [](int x, int y){ return x; },
        [](int x, int y){ return y; },
        [](int x, int y){ return x - y; },
        [](int x, int y){ return x + y; }
    };

    function<void(int, int, int, map<pair<int, int>, int>&)> intersect[] = {
        [](int v, int x, int y, map<pair<int, int>, int>& cnt) {
            if (x == v) {
                return;
            } else {
                cnt[{v, y}]++;
                cnt[{v, y - (x - v)}]++;
                cnt[{v, y + (x - v)}]++;
            }
        },
        [](int v, int x, int y, map<pair<int, int>, int>& cnt) {
            if (y == v) {
                return;
            } else {
                cnt[{x, v}]++;
                cnt[{x - (y - v), v}]++;
                cnt[{x + (y - v), v}]++;
            }
        },
        [](int v, int x, int y, map<pair<int, int>, int>& cnt) {
            if (x - y == v) {
                return;
            } else {
                if ((x + y + v) % 2 == 0)
                    cnt[{(x + y + v) / 2, (x + y - v) / 2}]++;
                cnt[{x, x - v}]++;
                cnt[{y + v, y}]++;
            }
        },
        [](int v, int x, int y, map<pair<int, int>, int>& cnt) {
            if (x + y == v) {
                return;
            } else {
                if ((x + y + v) % 2 == 0)
                    cnt[{(v + (x - y)) / 2, (v - (x - y)) / 2}]++;
                cnt[{x, v - x}]++;
                cnt[{v - y, y}]++;
            }
        }
    };

    for (int dir = 0; dir < 4; dir++) {
        map<int, int> at_line;
        for (int i = 0; i < n; i++)
            at_line[line[dir](x[i], y[i])]++;

        for (auto& [val, cnt] : at_line) {
            if (4 * cnt < n) continue;

            if (cnt == n) {
                cout << "YES\n";
                cout << x[0] << " " << y[0] << "\n";
                return;
            }

            map<pair<int, int>, int> beats;
            for (int i = 0; i < n; i++) {
                intersect[dir](val, x[i], y[i], beats);
            }

            for (auto& [cell, cell_cnt] : beats) {
                assert(cnt + cell_cnt <= n);
                if (cnt + cell_cnt == n) {
                    cout << "YES\n";
                    cout << cell.first << ' ' << cell.second << '\n';
                    return;
                }
            }
        }
    }
    cout << "NO\n";
}


int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}