#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <ctime>
#include <functional>
#include <iostream>
#include <map>
#include <numeric>
#include <random>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

#define int long long

const int N = 1e5 + 7;

int n;
struct Point {
  int x, y;
} q[N];

vector<Point> intersect(Point A, Point B) {
  int dx[4] = {0, 1, 1, 1};
  int dy[4] = {1, 0, 1, -1};
  vector<Point> res;
  for (int a = 0; a < 4; ++a) {
    for (int b = 0; b < 4; ++b) {
      if (a != b) {
        int a1 = dx[a];
        int a2 = dx[b];
        int b1 = dy[a];
        int b2 = dy[b];
        int c1 = -a1 * A.x - b1 * A.y;
        int c2 = -a2 * B.x - b2 * B.y;
        int x = (-c1 * b2 + c2 * b1) / (a1 * b2 - a2 * b1);
        int y = (-c1 * a2 + c2 * a1) / (b1 * a2 - b2 * a1);
        res.push_back({x, y});
      }
    }
  }
  return res;
}

bool check(Point A, Point B) {
  return A.x == B.x || A.y == B.y || abs(A.x - B.x) == abs(A.y - B.y);
}

bool check(Point I) {
  for (int i = 0; i < n; ++i) {
    if (!check(q[i], I)) {
      return false;
    }
  }
  return true;
}

signed main() {
  int t;
  cin >> t;
  while (t--) {
    cin >> n;
    for (int i = 0; i < n; ++i) {
      cin >> q[i].x >> q[i].y;
    }
    if (check(q[0])) {
      cout << "YES\n";
      cout << q[0].x << ' ' << q[0].y << '\n';
      continue;
    }
    bool flag = false;
    for (int i = 0; i < n; ++i) {
      if (!check(q[0], q[i])) {
        for (Point I : intersect(q[0], q[i])) {
          if (check(I)) {
            cout << "YES\n";
            cout << I.x << ' ' << I.y << '\n';
            flag = true;
            break;
          }
        }
        break;
      }
    }
    if (!flag) {
      cout << "NO\n";
    }
  }
  return 0;
}
/*
4
10 20 30 40
1 2 51 52
*/