#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <ctime>
#include <functional>
#include <iostream>
#include <map>
#include <numeric>
#include <random>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

vector<int> mask_order(int n) {
  if (n == 0) {
    return {};
  } else if (n == 1) {
    return {0, 1};
  } else {
    vector<int> res = mask_order(n - 1);
    int first = res.back() | 1 << n - 1;
    for (int mask : mask_order(n - 1)) {
      res.push_back(first ^ mask);
    }
    return res;
  }
}

int get(int p) {
  int res = -1;
  while (p) {
    ++res;
    p >>= 1;
  }
  return res;
}

int n, k;

void ask(int i, int j) {
  cout << i + 1 << ' ' << j + 1 << endl;
  cin >> k;
  if (k == n) {
    exit(0);
  }
}

signed main() {
  cin >> n >> k;
  if (k == n) {
    return 0;
  }
  for (int i = n - 1; i >= 0; --i) {
    vector<int> opt1 = {k};
    vector<int> order = mask_order(i);
    for (int j = 1; j < SZ(order); ++j) {
      ask(get(order[j] ^ order[j - 1]), i);
      opt1.push_back(k);
    }
    if (i != 0) {
      ask(i - 1, i);
    }
    ask(i, i);
    vector<int> opt2 = {k};
    for (int j = 1; j < SZ(order); ++j) {
      ask(get(order[j] ^ order[j - 1]), i);
      opt2.push_back(k);
    }
    if (i != 0) {
      ask(i - 1, i);
    }
    for (int j = 0; j < SZ(opt1); ++j) {
      if (opt1[j] != opt2[j]) {
        if (opt1[j] > opt2[j]) {
          ask(i, i);
        }
        for (int t = 0; t < i; ++t) {
          if (order[j] & (1 << t)) {
            ask(t, i);
          }
        }
        break;
      }
    }
  }
  return 0;
}
/*
3
0
0
0
1
0
0
0
0
0
0
0
*/