#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <ctime>
#include <functional>
#include <iostream>
#include <map>
#include <numeric>
#include <random>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

#define left _left
#define right _right

const int N = 10;

int n;
int a[N];
int b[N];
int p[N];
int left[N], right[N];
bool lc[N], rc[N];

void build_left() {
  int cur = 0;
  map<int, vector<int>> events;
  for (int i = n - 1; i >= 0; --i) {
    if (n - p[i] - 1 > cur) {
      ++cur;
      lc[i] = true;
    } else {
      events[(n - p[i] - 1) - 1].push_back(i);
    }
  }
  left[n] = cur;
  vector<int> def;
  for (int i = n - 1; i >= 0; --i) {
    if (lc[i]) {
      --cur;
      for (int j : events[cur]) {
        def.push_back(j);
      }
      events[cur].clear();
      while (!def.empty()) {
        if (def.back() >= i) {
          def.pop_back();
        } else {
          lc[def.back()] = true;
          def.pop_back();
          ++cur;
          break;
        }
      }
    }
    left[i] = cur;
  }
}

void build_right() {
  int cur = 0;
  map<int, vector<int>> events;
  for (int i = 0; i < n; ++i) {
    if (p[i] >= cur) {
      ++cur;
      rc[i] = true;
    } else {
      events[p[i]].push_back(i);
    }
  }
  right[0] = cur;
  vector<int> def;
  for (int i = 0; i < n; ++i) {
    if (rc[i]) {
      --cur;
      for (int j : events[cur]) {
        def.push_back(j);
      }
      events[cur].clear();
      while (!def.empty()) {
        if (def.back() <= i) {
          def.pop_back();
        } else {
          rc[def.back()] = true;
          def.pop_back();
          ++cur;
          break;
        }
      }
    }
    right[i + 1] = cur;
  }
}

signed main() {
  cin >> n;
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }
  for (int i = 0; i < n; ++i) {
    cin >> b[i];
  }
  for (int i = 0; i < n; ++i) {
    p[i] = lower_bound(b, b + n, a[i]) - b - 1;
  }
  build_left();
  build_right();
  set<int> ans;
  for (int i = 0; i <= n; ++i) {
    ans.insert((i - left[i]) + right[i]);
  }
  vector<int> vans(ALL(ans));
  sort(ALL(vans));
  cout << SZ(vans) << '\n';
  for (int x : vans) {
    cout << x << ' ';
  }
  cout << '\n';
  return 0;
}
/*
4
10 20 30 40
1 2 51 52
*/