#include <bits/stdc++.h>

using namespace std;

#define int long long

const int N = 1e6 + 1;

bool cover(const pair<int, int>& q, const pair<int, int>& p) {
    return q.first == p.first || q.second == p.second || abs(q.first - p.first) == abs(q.second - p.second);
}

bool check_candidate(const vector<pair<int, int>>& points, const pair<int, int>& c) {
    bool ok = true;
    for (auto p : points) {
        ok &= (cover(p, c) && (abs(c.first) <= 1e9 && abs(c.second) <= 1e9));
    }
    return ok;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int testc;
    cin >> testc;
    for (int _ = 0; _ < testc; _++) {
        int n;
        cin >> n;
        vector<pair<int, int>> points;
        for (int i = 0; i < n; i++) {
            int a, b;
            cin >> a >> b;
            points.push_back({a, b});
        }
        auto starting_point = points[0];
        vector<pair<int, int>> hor;
        vector<pair<int, int>> vert;
        pair<int, int> ans;
        bool found = false;
        for (int i = 1; i < n; i++) {
            auto cur_point = points[i];
            if (cur_point.first == starting_point.first) {
                hor.push_back(cur_point);
            } else if (cur_point.second == starting_point.second) {
                vert.push_back(cur_point);
            } else {
                ans = cur_point;
                found = true;
                break;
            }
        }
        if (!found) {
            if (hor.size() * vert.size() != 0) {
                starting_point = hor.front();
                ans = vert.front();
            } else {
                cout << "YES\n";
                cout << starting_point.first << ' ' << starting_point.second << '\n';
                continue;
            }
        }
        if (starting_point.first > ans.first) {
            swap(starting_point, ans);
        }
        pair<int, int> candidate1 = {starting_point.first, ans.second};
        pair<int, int> candidate2 = {starting_point.second, ans.first};
        if (check_candidate(points, candidate1)) {
            cout << "YES\n";
            cout << candidate1.first << ' ' << candidate1.second << '\n';
            continue;
        }
        if (check_candidate(points, candidate2)) {
            cout << "YES\n";
            cout << candidate2.first << ' ' << candidate2.second << '\n';
            continue;
        }

        vector<pair<int, int>> cands;
        // #1
        cands.emplace_back(ans.first + ans.second - starting_point.second, starting_point.second);

        // #2
        cands.emplace_back(ans.second - starting_point.second + starting_point.first, ans.second);

        // #3
        int q = ans.first + ans.second + starting_point.first - starting_point.second;
        if (q % 2 == 0) {
            cands.emplace_back(q / 2, ans.first + ans.second - (q / 2));
        }

        // #4
        cands.emplace_back(ans.first, ans.first + starting_point.second - starting_point.first);

        // #5
        cands.emplace_back(ans.first, starting_point.first + starting_point.second - ans.first);

        // #6
        cands.emplace_back(starting_point.first, ans.first + ans.second - starting_point.first);

        // #7
        cands.emplace_back(starting_point.first, starting_point.first + ans.second - ans.first);

        // #8
        int qq = starting_point.first + starting_point.second + ans.first - ans.second;
        if (qq % 2 == 0) {
            cands.emplace_back(qq / 2, starting_point.first + starting_point.second - (qq / 2));
        }

        // #9
        cands.emplace_back(ans.first - ans.second + starting_point.second, starting_point.second);

        // #10
        cands.emplace_back(starting_point.first + starting_point.second - ans.second, ans.second);

        bool ff = false;
        for (auto c : cands) {
            if (check_candidate(points, c)) {
                cout << "YES\n";
                cout << c.first << ' ' << c.second << '\n';
                ff = true;
                break;
            }
        }

        if (!ff) {
            cout << "NO\n";
            continue;
        }

//        cout << "NO\n";
//        continue;
//        if ((starting_point.first - ans.first) == (starting_point.second - ans.second)) {
//            // Лежат на одной диагонали (ukfdyjt)
//            pair<int, int> point;
//            bool f = false;
//            for (auto p: points) {
//                if ((p.first - ans.first) != (p.second - ans.second)) {
//                    point = p;
//                    f = true;
//                }
//            }
//            if (!f) {
//                cout << "YES\n";
//                cout << ans.first << ' ' << ans.second << '\n';
//                continue;
//            }
//            pair<int, int> candidate1 = {point.first, ans.second + point.first - ans.first};
//            pair<int, int> candidate2 = {ans.first - ans.second + point.second, point.second};
//            if (check_candidate(points, candidate1)) {
//                cout << "YES\n";
//                cout << candidate1.first << ' ' << candidate1.second << '\n';
//                continue;
//            } else if (check_candidate(points, candidate2)) {
//                cout << "YES\n";
//                cout << candidate2.first << ' ' << candidate2.second << '\n';
//                continue;
//            } else {
//                int a = ans.first - starting_point.first;
//                int b = point.first + point.second;
//                if ((a + b) % 2 == 0) {
//                    pair<int, int> candidate3 = {(a + b) / 2, (b - a) / 2};
//                    if (check_candidate(points, candidate3)) {
//                        cout << "YES\n";
//                        cout << candidate3.first << ' ' << candidate3.second << '\n';
//                        continue;
//                    } else {
//                        cout << "NO\n";
//                        continue;
//                    }
//                } else {
//                    cout << "NO\n";
//                    continue;
//                }
//            }
//        } else if (starting_point.first + starting_point.second == ans.first + ans.second) {
//            pair<int, int> point;
//            bool f = false;
//            for (auto p: points) {
//                if ((p.first + p.second) != (ans.first + ans.second)) {
//                    point = p;
//                    f = true;
//                }
//            }
//            if (!f) {
//                cout << "YES\n";
//                cout << ans.first << ' ' << ans.second << '\n';
//                continue;
//            }
//            pair<int, int> candidate1 = {point.first, ans.second + ans.first - point.first};
//            pair<int, int> candidate2 = {ans.first - point.second + ans.second, point.second};
//            if (check_candidate(points, candidate1)) {
//                cout << "YES\n";
//                cout << candidate1.first << ' ' << candidate1.second << '\n';
//                continue;
//            } else if (check_candidate(points, candidate2)) {
//                cout << "YES\n";
//                cout << candidate2.first << ' ' << candidate2.second << '\n';
//                continue;
//            } else {
//                if ((ans.first + ans.second + point.first - point.second) % 2 != 0) {
//                    cout << "NO\n";
//                    continue;
//                }
//                int x = (ans.first + ans.second + point.first - point.second) / 2;
//                int y = ans.first + ans.second - x;
//                pair<int, int> cand = {x, y};
//                if (check_candidate(points, cand)) {
//                    cout << "YES\n";
//                    cout << cand.first << ' ' << cand.second << '\n';
//                    continue;
//                } else {
//                    cout << "NO\n";
//                }
//            }
//        } else {
//            vector<pair<int, int>> cands;
//            // #1
//            cands.emplace_back(ans.first + ans.second - starting_point.second, starting_point.second);
//
//            // #2
//            cands.emplace_back(ans.second - starting_point.second + starting_point.first, ans.second);
//
//            // #3
//            int q = ans.first + ans.second + starting_point.first - starting_point.second;
//            if (q % 2 == 0) {
//                cands.emplace_back(q / 2, ans.first + ans.second - (q / 2));
//            }
//
//            // #4
//            cands.emplace_back(ans.first, ans.first + starting_point.second - starting_point.first);
//
//            // #5
//            cands.emplace_back(ans.first, starting_point.first + starting_point.second - ans.first);
//
//            // #6
//            cands.emplace_back(starting_point.first, ans.first + ans.second - starting_point.first);
//
//            // #7
//            cands.emplace_back(starting_point.first, starting_point.first + ans.second - ans.first);
//
//            // #8
//            int qq = starting_point.first + starting_point.second + ans.first - ans.second;
//            if (qq % 2 == 0) {
//                cands.emplace_back(qq / 2, starting_point.first + starting_point.second - (qq / 2));
//            }
//
//            // #9
//            cands.emplace_back(ans.first - ans.second + starting_point.second, starting_point.second);
//
//            // #10
//            cands.emplace_back(starting_point.first + starting_point.second - ans.second, ans.second);
//
//            bool ff = false;
//            for (auto c : cands) {
//                if (check_candidate(points, c)) {
//                    cout << "YES\n";
//                    cout << c.first << ' ' << c.second << '\n';
//                    ff = true;
//                    break;
//                }
//            }
//            if (!ff) {
//                cout << "NO\n";
//                continue;
//            }
//        }
    }
}
