#include <bits/stdc++.h>

using namespace std;

#define ll long long

#define all(v) begin(v), end(v)

/*
 * 0 - point
 * 1 - v line
 * 2 - h line
 * 3 - diag + - -
 *          - + -
 *          - - +
 * 4 - inverse diag
 */


#define int long long

void insert(vector<pair<int, pair<int, int>>> &st, pair<int, pair<int, int>> g, pair<int, int> p) {
    int x = g.second.first, y = g.second.second;
    if (g.first == 0) {
        if (x == p.first || y == p.second ||
            abs(x - p.first) == abs(y - p.second)) {
            st.push_back(g);
            return;
        } else return;
    } else if (g.first == 1) {
        if (p.first == x) {
            st.push_back(g);
            return;
        } else {
            st.push_back({0, {x, p.second}});
            st.push_back({0, {x, p.second - abs(x - p.first)}});
            st.push_back({0, {x, p.second + abs(x - p.first)}});
        }
    } else if (g.first == 2) {
        if (p.second == y) {
            st.push_back(g);
            return;
        } else {
            st.push_back({0, {p.first, y}});
            st.push_back({0, {p.first - abs(y - p.second), y}});
            st.push_back({0, {p.first + abs(y - p.second), y}});
        }
    } else if (g.first == 3) {
        if (p.first - x == y - p.second) {
            st.push_back(g);
            return;
        } else {
            st.push_back({0, {p.first, y - (p.first - x)}});
            st.push_back({0, {x + (y - p.second), p.second}});
            if ((x + y) % 2 == (p.first + p.second) % 2) {
                int k = (x + y - p.first - p.second) / 2;
                st.push_back({0, {p.first + k, p.second + k}});
            }
        }
    } else {
        if (p.first - x == p.second - y) {
            st.push_back(g);
            return;
        } else {
            st.push_back({0, {p.first, y + (p.first - x)}});
            st.push_back({0, {x + (p.second - y), p.second}});
            if ((x + y) % 2 == (p.first + p.second) % 2) {
                int k = (x - y - p.first + p.second) / 2;
                st.push_back({0, {p.first + k, p.second - k}});
            }
        }
    }
}

pair<bool, pair<int, int>> solve(int n, const vector<pair<int, int>> &v) {
    vector<pair<int, pair<int, int>>> st;
    int x, y;
//    cin >> x >> y;
    x = v[0].first;
    y = v[0].second;
    st.push_back({1, {x, y}});
    st.push_back({2, {x, y}});
    st.push_back({3, {x, y}});
    st.push_back({4, {x, y}});
    for (int i = 1; i < n; ++i) {
        x = v[i].first;
        y = v[i].second;
        vector<pair<int, pair<int, int>>> new_st(0);
        for (auto g : st) {
            insert(new_st, g, {x, y});
        }
        st = new_st;
    }
    if (st.empty()) {
        return {false, {0, 0}};
    } else {
        return {true, {st[0].second.first, st[0].second.second}};
    }
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<pair<int, int>> fs;
        for (int i = 0; i < n; ++i) {
            int x, y;
            cin >> x >> y;
            fs.push_back({x, y});
        }
        auto [f, p] = solve(n, fs);
        if (!f) {
            cout << "NO\n";
        } else {
            assert(abs(p.first) <= 1'000'000'000);
            assert(abs(p.second) <= 1'000'000'000);
            cout << "YES\n" << p.first << " " << p.second << '\n';
        }
    }

//    mt19937 rnd;
//    uniform_int_distribution<int> d(-30, 30);
//
//    while(true) {
//        map<pair<int, int>, int> tbl;
//        int n = 5;
//        vector<pair<int, int>> fs;
//        for (int i = 0; i < n; ++i) {
//            int x = d(rnd), y = d(rnd);
//            fs.push_back({x, y});
//            for (int j = -200; j < 200; ++j) tbl[{x, j}]++;
//            for (int j = -200; j < 200; ++j) tbl[{j, y}]++;
//            for (int j = -200; j < 200; ++j) tbl[{x + j, y + j}]++;
//            for (int j = -200; j < 200; ++j) tbl[{x + j, y - j}]++;
//            tbl[{x, y}] -= 3;
//        }
////        for (auto v : tbl) {for (auto x : v) cout << x << " "; cout << '\n';}
//        bool ans = false;
//        for (auto v : tbl) for (auto x : v) ans = ans || (x == n);
//        auto [f, p] = solve(n, fs);
//        if (ans != f || (f && tbl[p.first][p.second] != n)) {
//            cout << p.first << " " << p.second << '\n';
//            for (auto fer : fs) cout << fer.first << " " << fer.second << '\n';
//            break;
//        }
//    }
}