#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define f first
#define s second
#define _ << ' ' <<
#define sz(x) ((int) x.size())
#define all(x) x.begin(), x.end()
//#define int long long

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

//#pragma gcc optimize ("O3")
//#pragma gcc target ("avx, sse4")

using ld = long double;
using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

mt19937 rnd(1337228);

struct Node {
    int sz, prior;
    pii value;
    Node *L = nullptr, *R = nullptr, *P = nullptr;

    Node(pii value): value(value) {
        sz = 1;
        prior = rnd();
        L = nullptr;
        R = nullptr;
        P = nullptr;
    }
};

int get_sz(Node *tree) {
    if (!tree) return 0;
    return tree->sz;
}

void recalc(Node *tree) {
    if (!tree) return;
    tree->sz = get_sz(tree->L) + 1 + get_sz(tree->R);
    if (tree->L) tree->L->P = tree;
    if (tree->R) tree->R->P = tree;
}

pair<Node *, Node *> split(Node *tree, int k) {
    if (tree == nullptr) return {nullptr, nullptr};
    if (get_sz(tree->L) + 1 <= k) {
        auto p = split(tree->R, k - get_sz(tree->L) - 1);
        tree->R = p.first;
        recalc(tree);
        if (tree) tree->P = nullptr;
        if (p.second) p.second->P = nullptr;
        return {tree, p.second};
    } else {
        auto p = split(tree->L, k);
        tree->L = p.second;
        recalc(tree);
        if (p.first) p.first->P = nullptr;
        if (tree) tree->P = nullptr;
        return {p.first, tree};
    }
}

Node *merge(Node *lef, Node *rig) {
    if (!lef) return rig;
    if (!rig) return lef;
    if (lef->prior > rig->prior) {
        lef->R = merge(lef->R, rig);
        recalc(lef);
        if (lef) lef->P = nullptr;
        return lef;
    }
    rig->L = merge(lef, rig->L);
    recalc(rig);
    if (rig) rig->P = nullptr;
    return rig;
}

int get_pos(Node *node, bool from_right) {
    int an = from_right ? 1 + get_sz(node->L) : 0;
    if (!node->P) {
        return an;
    }
    if (node == node->P->L) {
        return an + get_pos(node->P, false);
    }
    return an + get_pos(node->P, true);
}

Node *root = nullptr;
map<pii, Node *> nodes;

void print(Node *tree) {
    if (!tree) return;
    print(tree->L);
    print(tree->R);
}

void insert_begin(pii x) {
    Node *newNode = new Node(x);
    nodes[x] = newNode;
    root = merge(newNode, root);
}

void insert_after(pii x, pii y) {
    Node *node = nodes[x];
    Node *newNode = new Node(y);
    nodes[y] = newNode;
    int pos = get_pos(node, true);
    auto p = split(root, pos);
    root = merge(p.first, merge(newNode, p.second));
}

void insert_end(pii x) {
    Node *newNode = new Node(x);
    nodes[x] = newNode;
    root = merge(root, newNode);
}

bool is_earlier(pii x, pii y) {
    return get_pos(nodes[x], true) < get_pos(nodes[y], true);
}

vector<pii> aoaoao;
map<pii, int> idx;

void calc(Node *tree) {
    if (!tree) return;
    calc(tree->L);
    aoaoao.push_back(tree->value);
    calc(tree->R);
}

void solve() {
    int n, m;
    cin >> n >> m;

    vector<string> types(n - 1);

    for (auto &s : types) {
        cin >> s;
    }

    for (int x = 0; x < n; ++x) {
        insert_end({x, 0});
    }
    for (int y = 1; y < m; ++y) {
        insert_end({0, y});
    }

    for (int r = 1; r < n; ++r) {
        for (int c = 1; c < m; ++c) {
            pii r1 = {r - 1, c - 1},
                r2 = {r - 1, c},
                r3 = {r, c - 1},
                r4 = {r, c};

            bool e12 = is_earlier(r1, r2),
                e23 = is_earlier(r2, r3),
                e31 = is_earlier(r3, r1);

            int type = types[r - 1][c - 1] - '0';

            if (type == 1) {
                if (e31 && e12) {
                    insert_after(r3, r4);
                } else if (e12 && e23) {
                    insert_end(r4);
                } else if (e23 && e31) {
                    insert_after(r3, r4);
                } else if (!e31 && !e23) {
                    insert_after(r1, r4);
                } else if (!e23 && !e12) {
                    insert_end(r4);
                } else if (!e12 && !e31) {
                    insert_after(r1, r4);
                }
            } else if (type == 2) {
                if (e31 && e12) { // 312
                    insert_end(r4);
                } else if (e12 && e23) { // 123
                    insert_after(r2, r4);
                } else if (e23 && e31) { // 231
                    insert_after(r2, r4);
                } else if (!e31 && !e23) { // 132
                    insert_after(r3, r4);
                } else if (!e23 && !e12) { // 321
                    insert_after(r3, r4);
                } else if (!e12 && !e31) { // 213
                    insert_end(r4);
                }
            } else if (type == 3) {
                if (e31 && e12) { // 312
                    insert_after(r1, r4);
                } else if (e12 && e23) { // 123
                    insert_after(r1, r4);
                } else if (e23 && e31) { // 231
                    insert_after(r1, r4);
                } else if (!e31 && !e23) { // 132
                    insert_after(r2, r4);
                } else if (!e23 && !e12) { // 321
                    insert_after(r2, r4);
                } else if (!e12 && !e31) { // 213
                    insert_after(r2, r4);
                }
            }
        }
    }
    calc(root);
    vector<vector<int>> ans(n, vector<int>(m, 0));
    for (int i = 0; i < (int) aoaoao.size(); ++i) {
        pii p = aoaoao[i];
        ans[p.first][p.second] = i + 1;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << ans[i][j] << " ";
        }
        cout << "\n";
    }
}

signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }

    return 0;
}

