#pragma GCC optimize("Ofast")

#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include <cstdint>
#include<cmath>
using namespace std;
//#define int long long

//1 y - horizontal
//2 x - vertical
//3 x-y - diag right up
//4 x+y - diag right down
//5 x y - point
struct v3 {
	int a[3];
	v3() {
		a[0] = 0;
		a[1] = 0;
		a[2] = 0;
	}
	v3(int x, int y, int z) {
		a[0] = x;
		a[1] = y;
		a[2] = z;
	}
	int& operator[] (int x) {
		return a[x];
	}
};

v3 intersect(v3& a, v3& b) {
	v3 empty = { -1, -1, -1 };
	if (a[0] > b[0]) {
		return intersect(b, a);
	}
	vector<v3> res;
	if (a[0] == b[0]) {
		if (a[1] == b[1] && a[2] == b[2]) {
			return a;
		}
		return empty;
	}
	if (b[0] == 5) {
		if (a[0] == 1) {
			if (b[2] == a[1]) {
				return b;
			}
			else {
				return empty;
			}
		}
		else if (a[0] == 2) {
			if (b[1] == a[1]) {
				return b;
			}
			else {
				return empty;
			}
		}
		else if (a[0] == 3) {
			if (b[1] - b[2] == a[1]) {
				return b;
			}
			else {
				return empty;
			}
		}
		else if (a[0] == 4) {
			if (b[1] + b[2] == a[1]) {
				return b;
			}
			else {
				return empty;
			}
		}
	}
	if (a[0] == 1) {
		if (b[0] == 2) {
			return { 5, b[1], a[1] };
		}
		else if (b[0] == 3) {
			return { 5, a[1] + b[1], a[1] };
		}
		else if (b[0] == 4) {
			return { 5, b[1] - a[1], a[1] };
		}
	}
	if (a[0] == 2 && b[0] == 3) {
		return { 5, a[1], a[1] - b[1] };
	}
	if (a[0] == 2 && b[0] == 4) {
		return { 5, a[1], b[1] - a[1] };
	}
	if (a[0] == 3 && b[0] == 4) {
		if ((a[1] + b[1]) % 2 == 0) {
			int x = (a[1] + b[1]) / 2;
			int y = b[1] - x;
			return { 5, x, y };
		}
		else {
			return empty;
		}
	}
}

vector<v3> lines(int x, int y) {
	return { { 1, y, 0 }, { 2, x, 0 }, { 3, x - y, 0 }, { 4, x + y, 0 } };
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int t;
	cin >> t;
	for (int _ = 0; _ < t; ++_) {
		int n;
		cin >> n;
		int x, y;
		cin >> x >> y;
		vector<v3> objects = lines(x, y);
		for (int i = 1; i < n; ++i) {
			cin >> x >> y;
			auto lines1 = lines(x, y);
			vector<v3> objects1;
			for (auto& line : lines1) {
				for (auto& obj : objects) {
					auto inter = intersect(obj, line);
					if (inter[0] > 0) {
						objects1.push_back(inter);
					}
				}
			}
			objects = objects1;
			if (objects.empty()) {
				break;
			}
		}
		if (objects.empty()) {
			cout << "NO\n";
		}
		else {
			cout << "YES\n";
			auto res = objects[0];
			if (res[0] == 5) {
				cout << res[1] << ' ' << res[2] << '\n';
			}
			if (res[0] == 1) {
				cout << 0 << ' ' << res[1] << '\n';
			}
			if (res[0] >= 2 && res[0] <= 4) {
				cout << res[1] << ' ' << 0 << '\n';
			}
		}
	}
	return 0;
}