#pragma GCC optimize("Ofast")

#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include <cstdint>
#include<cmath>
#include<set>
using namespace std;
//#define int long long

//1 y - horizontal
//2 x - vertical
//3 x-y - diag right up
//4 x+y - diag right down
//5 x y - point
struct v3 {
	int a[3];
	v3() {
		a[0] = 0;
		a[1] = 0;
		a[2] = 0;
	}
	v3(int x, int y, int z) {
		a[0] = x;
		a[1] = y;
		a[2] = z;
	}
	int& operator[] (int x) {
		return a[x];
	}
};

v3 intersect(v3& a, v3& b) {
	v3 empty = { -1, -1, -1 };
	if (a[0] > b[0]) {
		return intersect(b, a);
	}
	vector<v3> res;
	if (a[0] == b[0]) {
		if (a[1] == b[1] && a[2] == b[2]) {
			return a;
		}
		return empty;
	}
	if (b[0] == 5) {
		if (a[0] == 1) {
			if (b[2] == a[1]) {
				return b;
			}
			else {
				return empty;
			}
		}
		else if (a[0] == 2) {
			if (b[1] == a[1]) {
				return b;
			}
			else {
				return empty;
			}
		}
		else if (a[0] == 3) {
			if (b[1] - b[2] == a[1]) {
				return b;
			}
			else {
				return empty;
			}
		}
		else if (a[0] == 4) {
			if (b[1] + b[2] == a[1]) {
				return b;
			}
			else {
				return empty;
			}
		}
	}
	if (a[0] == 1) {
		if (b[0] == 2) {
			return { 5, b[1], a[1] };
		}
		else if (b[0] == 3) {
			return { 5, a[1] + b[1], a[1] };
		}
		else if (b[0] == 4) {
			return { 5, b[1] - a[1], a[1] };
		}
	}
	if (a[0] == 2 && b[0] == 3) {
		return { 5, a[1], a[1] - b[1] };
	}
	if (a[0] == 2 && b[0] == 4) {
		return { 5, a[1], b[1] - a[1] };
	}
	if (a[0] == 3 && b[0] == 4) {
		if ((a[1] + b[1]) % 2 == 0) {
			int x = (a[1] + b[1]) / 2;
			int y = b[1] - x;
			return { 5, x, y };
		}
		else {
			return empty;
		}
	}
}

vector<v3> lines(int x, int y) {
	return { { 1, y, 0 }, { 2, x, 0 }, { 3, x - y, 0 }, { 4, x + y, 0 } };
}

bool eq(v3& a, v3& b) {
	return a[0] == b[0] && a[1] == b[1] && a[2] == b[2];
}

vector<v3> intersect_all(vector<v3> a, vector<v3> b) {
	vector<v3> res;
	for (auto& x : a) {
		for (auto& y : b) {
			auto inter = intersect(x, y);
			if (inter[0] > 0) {
				res.push_back(inter);
			}
		}
	}
	return res;
}

bool beat(pair<int, int> &a, pair<int, int> &b) {
	return a.first == b.first || a.second == b.second || abs(a.first - b.first) == abs(a.second - b.second);
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int t;
	cin >> t;
	for (int _ = 0; _ < t; ++_) {
		int n;
		cin >> n;
		vector<pair<int, int>> xy(n);
		for (int i = 0; i < n; ++i) {
			cin >> xy[i].first >> xy[i].second;
		}
		auto lines_ = lines(xy[0].first, xy[0].second);
		vector<pair<int, int>> points;
		for (int i = 1; i < n; ++i) {
			auto lines2 = lines(xy[i].first, xy[i].second);
			vector<v3> lines1;
			for (int j = 0; j < lines_.size(); ++j) {
				if (eq(lines_[j], lines2[lines_[j][0] - 1])) {
					lines1.push_back(lines_[j]);
				}
			}
			lines_ = lines1;
			if (lines1.empty()) {
				auto inter = intersect_all(lines(xy[0].first, xy[0].second), lines(xy[1].first, xy[1].second));
				if (i > 1) {
					inter = intersect_all(inter, lines(xy[i].first, xy[i].second));
				}
				for (auto obj : inter) {
					points.push_back({ obj[1], obj[2] });
				}
				break;
			}
		}
		if (!lines_.empty()) {
			cout << "YES\n";
			auto res = lines_[0];
			if (res[0] == 1) {
				cout << 0 << ' ' << res[1] << '\n';
			}
			if (res[0] >= 2 && res[0] <= 4) {
				cout << res[1] << ' ' << 0 << '\n';
			}
		}
		else {
			bool found = false;
			for (auto point : points) {
				bool flag = true;
				for (int i = 0; i < n; ++i) {
					if (!beat(xy[i], point)) {
						flag = false;
						break;
					}
				}
				if (flag) {
					cout << "YES\n" << point.first << ' ' << point.second << '\n';
					found = true;
					break;
				}
			}
			if (!found) {
				cout << "NO\n";
			}
		}
	}
	return 0;
}