#include <bits/stdc++.h>
#define int long long

using namespace std;

struct Point {
    int x, y;

    bool operator<(const Point& other) const {
        return x != other.x ? x < other.x : y < other.y;
    }
};

set<Point> find_intersections(Point a, Point b) {
    set<Point> intersection;
    intersection.insert({a.x, b.y});
    intersection.insert({a.y, b.x});
    int diff_y = abs(b.y - a.y);
    int diff_x = abs(b.x - a.x);
    intersection.insert({b.x, a.y - diff_x});
    intersection.insert({b.x, a.y + diff_x});
    intersection.insert({a.x, b.y + diff_x});
    intersection.insert({a.x, b.y - diff_x});
    intersection.insert({b.x - diff_y, a.y});
    intersection.insert({b.x + diff_y, a.y});
    intersection.insert({a.x - diff_y, b.y});
    intersection.insert({a.x + diff_y, b.y});
    int full_hypot = diff_x + diff_y;
    if (full_hypot % 2 == 0) {
        intersection.insert({a.x + full_hypot / 2, a.y + full_hypot / 2});
        intersection.insert({b.x - full_hypot / 2, b.y - full_hypot / 2});
    }
    return intersection;
}

bool point_ok(Point point, Point p) {
    int diff_x = abs(point.x - p.x);
    int diff_y = abs(point.y - p.y);
    if (diff_x == 0 || diff_y == 0 || diff_x == diff_y) {
        return true;
    } else {
        return false;
    }
}

bool all_ok(Point point, const vector<Point>& points) {
    for (const auto& p : points) {
        if (!point_ok(point, p)) {
            return false;
        }
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    vector<Point> points(n);
    for (auto& [x, y] : points) {
        cin >> x >> y;
    }
    sort(points.begin(), points.end());
    // TODO: find i & j such as i.x <= j.x
    int i = 0, true_j = -1;
    for (int j = 1; j < points.size(); ++j) {
        if (!point_ok(points[i], points[j])) {
            true_j = j;
            break;
        }
    }
    if (true_j == -1) {
        cout << "YES\n";
        cout << points[0].x << " " << points[0].y << "\n";
        return;
    }
    set<Point> suspicious = find_intersections(points[i], points[true_j]);
    for (const auto& point : suspicious) {
        if (all_ok(point, points)) {
            cout << "YES\n";
            cout << point.x << " " << point.y << "\n";
            return;
        }
    }
    cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}
