#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<vector<vector<int>>> calc_stack(int n, vector<int>& a, vector<int>& b) {
    vector<vector<vector<int>>> full_stack(n + 1, vector<vector<int>>(n + 1));
    full_stack[0][0] = vector<int>{};

    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {

            vector<int> stack = full_stack[i][j];
            vector<int> updated_stack = stack;
            updated_stack.push_back(a[i]);
            if (i + 1 <= n) {
                full_stack[i + 1][j] = updated_stack;
            }
            if (!stack.empty() && stack.back() == b[j] && j + 1 <= n) {
                vector<int> updated_stack2 = stack;
                updated_stack2.pop_back();
                full_stack[i][j + 1] = updated_stack2;
            }

//            cout << "i = " << i << ", j = " << j << endl;
//            for (const auto& x : stack) {
//                cout << x << " ";
//            }
//            cout << endl;

        }
    }

    return full_stack;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    for (auto& x : a) {
        cin >> x;
    }
    for (auto& x : b) {
        cin >> x;
    }
    vector<vector<vector<int>>> stack = calc_stack(n, a, b);
    vector<vector<int>> dp(n + 1, vector<int>(n + 1));
    vector<vector<pair<int, int>>> parent(n + 1, vector<pair<int, int>>(n + 1, {-1, -1}));
    dp[0][0] = 1;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            if (dp[i][j]) {
                if (i + 1 <= n) {
                    dp[i + 1][j] = 1;
                    parent[i + 1][j] = {i, j};
                }
//                if (i == 4 && j == 3) {
//                    cout << "kek " << stack[i][j].back() << " " << b[j] << endl;
//                }
                if (j + 1 <= n && !stack[i][j].empty() && stack[i][j].back() == b[j]) {
                    dp[i][j + 1] = 1;
                    parent[i][j + 1] = {i, j};
                }
            }
        }
    }
//    for (int i = 0; i <= n; ++i) {
//        for (int j = 0; j <= n; ++j) {
//            cout << dp[i][j] << " ";
//        }
//        cout << "\n";
//    }
    if (dp[n][n] == 0) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
        string path;
        for (pair<int, int> pos = {n, n}; pos != pair{-1LL, -1LL}; ) {
            pair<int, int> prev = {parent[pos.first][pos.second].first, parent[pos.first][pos.second].second};
            if (prev.first != pos.first) {
                path += "S";
            } else {
                path += "C";
            }
            pos = prev;
        }
        path.pop_back();
        reverse(path.begin(), path.end());
        cout << path << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
    return 0;
}
