#include <bits/stdc++.h>

using namespace std;
using ll = long long;

using point = pair<ll, ll>;

struct line {
    point start;
    point dir;
};

using intersec = variant<set<point>, line>;

#define X first
#define Y second

bool same_color(point a, point b) {
    return (a.X - b.X + a.Y - b.Y) % 2 == 0;
}

intersec point_line_intersection(point a, line l) {
    set<point> res;
    if (l.dir == point{1, 0}) {
        res = {{a.X, l.start.Y}, {a.X + (l.start.Y - a.Y), l.start.Y}, {a.X - (l.start.Y - a.Y), l.start.Y}};
    } else if (l.dir == point{0, 1}) {
        res = {{l.start.X, a.Y}, {l.start.X, a.Y + (l.start.X - a.X)}, {l.start.X, a.Y - (l.start.X - a.X)}};
    } else if (l.dir == point{1, 1}) {
        res = {{a.X, l.start.Y + (a.X - l.start.X)}, {l.start.X + (a.Y - l.start.Y), a.Y}};
        if (same_color(l.start, a)) {
            res.insert({(a.X + a.Y - l.start.X - l.start.Y) / 2, (l.start.X - l.start.Y + a.Y - a.X) / 2});
        }
    } else if (l.dir == point{1, -1}) {
        res = {{a.X, l.start.Y - (a.X - l.start.X)}, {l.start.X - (a.Y - l.start.Y), a.Y}};
        if (same_color(l.start, a)) {
            res.insert({(a.X-a.Y+l.start.Y-l.start.X) / 2, (l.start.X+l.start.Y-a.X-a.Y) / 2});
        }
    }
    return res;
}

set<point> points_intersection_impl(point a, point b) {
    if (a.X > b.X) {
        return points_intersection_impl(b, a);
    }
    set<point> res = {{a.X, b.Y}, {b.X, a.Y}};
    if (same_color(a, b)) {
        res.insert({(b.X+b.Y-a.X-a.Y)/2,(a.X-a.Y+b.Y-b.X)/2});
        res.insert({(a.X+a.Y-b.X-b.Y)/2,(b.X-b.Y+a.Y-a.X)/2});
    }
    return res;
}

intersec points_intersection(point a, point b) {
    if (a.X > b.X) {
        return points_intersection(b, a);
    }
    if (a.X == b.X) {
        return line{a, {0, 1}};
    } else if (a.Y == b.Y) {
        return line{a, {1, 0}};
    } else if (a.Y - b.Y == a.X - b.X) {
        return line{a, {1, 1}};
    } else if (a.Y - b.Y == -1 * (a.X - b.X)) {
        return line{a, {1, -1}};
    } else {
        return points_intersection_impl(a, b);
    }
}

int main() {
    int t;
    cin >> t;
    while(t--) {
        ll n;
        cin >> n;
        vector<point> ps(n);
        for (auto& [x, y] : ps) {
            cin >> x >> y;
        }
        if (n == 1) {
            cout << "YES\n";
            cout << ps[0].X << " " << ps[0].Y << '\n';
            continue;
        }
        intersec cur = points_intersection(ps[0], ps[1]);
        for (int i = 2; i < n; i++) {
            if (cur.index() == 0) {
                set<point> neww;
                for (const auto& [x, y]: get<0>(cur)) {
                    if (x == ps[i].X || y == ps[i].Y || x - ps[i].X == y - ps[i].Y || x - ps[i].X == ps[i].Y - y) {
                        neww.insert({x, y});
                    }
                }
                cur = neww;
            } else if (cur.index() == 1) {
                cur = point_line_intersection(ps[i], get<1>(cur));
            }
        }
        if (cur.index() == 0) {
            auto res = get<0>(cur);
            if (res.empty()) {
                cout << "NO\n";
            } else {
                cout << "YES\n";
                cout << res.begin()->X << " " << res.begin()->Y << '\n';
            }
        } else {
            auto res = get<1>(cur);
            cout << "YES\n";
            cout << res.start.X << " " << res.start.Y << '\n';
        }
    }
//    ll n, p, mod;
//    cin >> n >> p >> mod;
//    n -= p;
//    map<ll, map<ll, ll>> cnts;
//    vector<vector<map<ll, ll>>> dp(n + 1, vector<map<ll, ll>>(n + 1));
//    dp[1][1][p] = 1;
//    for (ll i = 2; i <= n; i++) {
//        for (ll j = i; j > 0; j--) {
//            for (auto&& [x, v] : dp[i - j][min(j, i - j)]) {
//                dp[i][j][x ^ j] += v;
//                dp[i][j][x ^ j] %= mod;
//            }
//        }
//    }
//    ll ans = 0;
//    for (int i = 1; i <= n; i++) {
//        ans += dp[n][i][0];
//    }
//    cout << ans << endl;
}
