#include <bits/stdc++.h>

using namespace std;
using ll = long long;

using point = pair<ll, ll>;

struct line {
    point start;
    point dir;
};

using intersec = pair<set<point>, line>;

#define X first
#define Y second

bool same_color(point a, point b) {
    return (a.X - b.X + a.Y - b.Y) % 2 == 0;
}

bool is_on_the_line(point a, line l) {
    if (l.dir == point{1, 0}) {
        return l.start.Y == a.Y;
    } else if (l.dir == point{0, 1}) {
        return l.start.X == a.X;
    } else if (l.dir == point{1, 1}) {
        return l.start.X - a.X == l.start.Y - a.Y;
    } else if (l.dir == point{1, -1}) {
        return l.start.X - a.X == a.Y - l.start.Y;
    } else {
        return false;
    }
}

intersec point_line_intersection(point a, line l) {
    if (is_on_the_line(a, l)) {
        return {{}, l};
    }
    set<point> res;
    if (l.dir == point{1, 0}) {
        res = {{a.X, l.start.Y}, {a.X + (l.start.Y - a.Y), l.start.Y}, {a.X - (l.start.Y - a.Y), l.start.Y}};
    } else if (l.dir == point{0, 1}) {
        res = {{l.start.X, a.Y}, {l.start.X, a.Y + (l.start.X - a.X)}, {l.start.X, a.Y - (l.start.X - a.X)}};
    } else if (l.dir == point{1, 1}) {
        res = {{a.X, l.start.Y + (a.X - l.start.X)}, {l.start.X + (a.Y - l.start.Y), a.Y}};
        if (same_color(l.start, a)) {
            res.insert({a.X + (l.start.X - l.start.Y + a.Y - a.X) / 2, a.Y - (l.start.X - l.start.Y + a.Y - a.X) / 2});
        }
    } else if (l.dir == point{1, -1}) {
        res = {{a.X, l.start.Y - (a.X - l.start.X)}, {l.start.X - (a.Y - l.start.Y), a.Y}};
        if (same_color(l.start, a)) {
            res.insert({a.X + (l.start.X+l.start.Y-a.X-a.Y) / 2, a.Y + (l.start.X+l.start.Y-a.X-a.Y) / 2});
        }
    }
    return {res, {{}, {0, 0}}};
}

set<point> points_intersection_impl(point a, point b) {
    if (a.X > b.X) {
        return points_intersection_impl(b, a);
    }
    set<point> res = {{a.X, b.Y}, {b.X, a.Y}};
    if (same_color(a, b)) {
        res.insert({a.X + (b.X-b.Y+a.Y-a.X)/2,a.Y - (b.X-b.Y+a.Y-a.X)/2});
        res.insert({a.X + (b.X+b.Y-a.X-a.Y)/2, a.Y + (b.X+b.Y-a.X-a.Y)/2});
    }
    return res;
}

intersec points_intersection(point a, point b) {
    if (a.X > b.X) {
        return points_intersection(b, a);
    }
    line res;
    if (a.X == b.X) {
        res = line{a, {0, 1}};
    } else if (a.Y == b.Y) {
        res = line{a, {1, 0}};
    } else if (a.Y - b.Y == a.X - b.X) {
        res = line{a, {1, 1}};
    } else if (a.Y - b.Y == -1 * (a.X - b.X)) {
        res = line{a, {1, -1}};
    } else {
        res = line{{}, {0, 0}};
    }
    return {points_intersection_impl(a, b), res};
}

int main() {
    int t;
    cin >> t;
    while(t--) {
        ll n;
        cin >> n;
        vector<point> ps(n);
        for (auto& [x, y] : ps) {
            cin >> x >> y;
        }
        if (n == 1) {
            cout << "YES\n";
            cout << ps[0].X << " " << ps[0].Y << '\n';
            continue;
        }
        intersec cur = points_intersection(ps[0], ps[1]);
        for (int i = 2; i < n; i++) {
            intersec a = point_line_intersection(ps[i], cur.second);
            set<point> neww;
            for (const auto& [x, y]: cur.first) {
                if (x == ps[i].X || y == ps[i].Y || x - ps[i].X == y - ps[i].Y || x - ps[i].X == ps[i].Y - y) {
                    neww.insert({x, y});
                }
            }
            neww.insert(a.first.begin(), a.first.end());
            cur = {neww, a.second};
        }
        if (cur.second.dir != point{0,0}) {
            cout << "YES\n";
            cout << cur.second.start.X << " " << cur.second.start.Y << '\n';
        } else if (!cur.first.empty()) {
            cout << "YES\n";
            cout << cur.first.begin()->X << " " << cur.first.begin()->Y << '\n';
        } else {
            cout << "NO\n";
        }
    }
//    ll n, p, mod;
//    cin >> n >> p >> mod;
//    n -= p;
//    map<ll, map<ll, ll>> cnts;
//    vector<vector<map<ll, ll>>> dp(n + 1, vector<map<ll, ll>>(n + 1));
//    dp[1][1][p] = 1;
//    for (ll i = 2; i <= n; i++) {
//        for (ll j = i; j > 0; j--) {
//            for (auto&& [x, v] : dp[i - j][min(j, i - j)]) {
//                dp[i][j][x ^ j] += v;
//                dp[i][j][x ^ j] %= mod;
//            }
//        }
//    }
//    ll ans = 0;
//    for (int i = 1; i <= n; i++) {
//        ans += dp[n][i][0];
//    }
//    cout << ans << endl;
}
