#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <set>
#include <queue>

#define ll long long

using namespace std;

int solve();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}

bool sameH(int x1, int y1, int x2, int y2) {
    return y1 == y2;
}
bool sameV(int x1, int y1, int x2, int y2) {
    return x1 == x2;
}
bool sameD1(int x1, int y1, int x2, int y2) {
    return x1 + y1 == x2 + y2;
}
bool sameD2(int x1, int y1, int x2, int y2) {
    return x1 - y1 == x2 - y2;
}

vector<pair<int, int>> d;

bool check(int x, int y) {
    for (int i = 0; i < d.size(); i++) {
        if (sameD1(x, y, d[i].first, d[i].second))
            continue;
        if (sameD2(x, y, d[i].first, d[i].second))
            continue;
        if (sameH(x, y, d[i].first, d[i].second))
            continue;
        if (sameV(x, y, d[i].first, d[i].second))
            continue;
        return false;
    }
    return true;
}

int solve() {
    int qq;
    cin >> qq;
for (int iqq = 0; iqq < qq; iqq++) {
    d.clear();
    int n;
    cin >> n;
    int x1, y1;
    cin >> x1 >> y1;
    if (n == 1) {
        cout << "YES\n";
        cout << x1 << " " << y1 << "\n";
        continue;
    }
    int x2, y2;
    cin >> x2 >> y2;

    vector<pair<int, int>> p;
    p.push_back({x1, y2});
    p.push_back({x2, y1});
    p.push_back({x2 + y2 - y1, y1});
    p.push_back({y1 + x2 - y2, y1});
    p.push_back({x1, x2 + y2 - x1});
    p.push_back({x1, y2 - x2 + x1});
    p.push_back({x2, y1 - x1 + x2});
    p.push_back({x2, x1 + y1 - x2});
    p.push_back({y2 + x1 - y1, y2});
    p.push_back({x1 + y1 - y2, y2});

    if ((x1 + y1 - (x2 - y2)) % 2 == 0) {
        p.push_back({(x1 + y1 + x2 - y2) / 2, (x1 + y1 - x2 + y2) / 2});
        p.push_back({(x2 + y2 + x1 - y1) / 2, (x2 + y2 - x1 + y1) / 2});
    }

    d.resize(n-2);
    for (int in = 0; in < n-2; in++) {
        cin >> d[in].first >> d[in].second;
    }

    bool flag = false;
    for (int i = 0; i < p.size() && !flag; i++) {
        int x = p[i].first;
        int y = p[i].second;
        if (check(x, y)) {
            cout << "YES\n" << x << " " << y << "\n";
            flag = true;
            break;
        }
    }
    if (flag)
        continue;

    int type = 0;
    if (sameD1(x1, y1, x2, y2))
        type = 1;
    if (sameD2(x1, y1, x2, y2))
        type = 2;
    if (sameH(x1, y1, x2, y2))
        type = 3;
    if (sameV(x1, y1, x2, y2))
        type = 4;
    if (type == 0) {
        cout << "NO\n";
        continue;
    }

    int non = -1;
    for (int i = 0; i < n - 2 && non == -1; i++) {
        switch (type) {
            case 1:
                if (!sameD1(x1, y1, d[i].first, d[i].second))
                    non = i;
                break;
            case 2:
                if (!sameD1(x1, y1, d[i].first, d[i].second))
                    non = i;
                break;
            case 3:
                if (!sameD1(x1, y1, d[i].first, d[i].second))
                    non = i;
                break;
            case 4:
                if (!sameD1(x1, y1, d[i].first, d[i].second))
                    non = i;
                break;
        }
    }
    if (non != -1) {
        d.push_back({x2, y2});
        x2 = d[non].first;
        y2 = d[non].second;
        p.clear();
        p.push_back({x1, y2});
        p.push_back({x2, y1});
        p.push_back({x2 + y2 - y1, y1});
        p.push_back({y1 + x2 - y2, y1});
        p.push_back({x1, x2 + y2 - x1});
        p.push_back({x1, y2 - x2 + x1});
        p.push_back({x2, y1 - x1 + x2});
        p.push_back({x2, x1 + y1 - x2});
        p.push_back({y2 + x1 - y1, y2});
        p.push_back({x1 + y1 - y2, y2});

        if ((x1 + y1 - (x2 - y2)) % 2 == 0) {
            p.push_back({(x1 + y1 + x2 - y2) / 2, (x1 + y1 - x2 + y2) / 2});
            p.push_back({(x2 + y2 + x1 - y1) / 2, (x2 + y2 - x1 + y1) / 2});
        }

        flag = false;
        for (int i = 0; i < p.size() && !flag; i++) {
            int x = p[i].first;
            int y = p[i].second;
            if (check(x, y)) {
                cout << "YES\n" << x << " " << y << "\n";
                flag = true;
                break;
            }
        }
        if (flag)
            continue;
    }

    cout << "NO\n";
}
    return 0;
}