#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <set>
#include <queue>
#include <cassert>

#define ll long long

using namespace std;

int solve();

const int N = 10;
vector<int> a;
int pr_ans = -1, cur_ans = -1;
int sz, init;

void generate(int n, int k) {
    if (n + 1 == k) {
        return;
    }
    if (k == 1) {
        a.push_back(0);
        a.push_back(1);
    } else {
        vector<int> b = a;
        reverse(b.begin(), b.end());
        for (int i = 0; i < a.size(); i++) {
            a[i] *= 2;
        }
        for (int i = 0; i < b.size(); i++) {
            a.push_back(b[i] * 2 + 1);
        }
    }
    generate(n, k + 1);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    generate(N, 0);
    solve();
    return 0;
}

void query(int a, int b) {
    pr_ans = cur_ans;
    cout << a << ' ' << b << endl;
    int ans;
    cin >> ans;
    if (ans == sz) {
        exit(0);
    }
    cur_ans = ans;
}

int get_log(int n) {
    int x = 0;
    while (n > 0) {
        n /= 2;
        x++;
    }
    return x - 1;
}

vector<int> get_turns(int k) {
    vector<int> fitted, ans;
    for (int i = 0; i < (1 << k); i++) {
        fitted.push_back(a[i] >> (N - k));
    }
    for (int i = 1; i < fitted.size(); i++) {
        ans.push_back(get_log(fitted[i] ^ fitted[i - 1]));
    }
    return ans;
}

pair<int, int> find_empty(int n, int m) {
    for (int i = n; i <= m; i++) {
        query(i, i);
        if (cur_ans == pr_ans + 1) {
            return {i, 1};
        }
        if (cur_ans == pr_ans - 1) {
            query(i, i);
            return {i, 0};
        }
    }
    // VERIFY: not here
}

void clearify(int n, int m, int num_zero_cells) {
    if (m < n) {
        return;
    }
    if (n == m) {
        if (num_zero_cells == 1) {
            return;
        }
        query(n, m);
        return;
    }
    if (num_zero_cells > 0) {
        auto ind = find_empty(n, m);
        clearify(n, ind.first - 1, 0);
        clearify(ind.first + 1, m, num_zero_cells - 1 + ind.second);
        return;
    }
    vector<int> turns = get_turns(m - n + 1);
    for (int turn : turns) {
        query(n, n + turn);
        if (cur_ans > pr_ans) {
            auto ind = find_empty(n, m);
            clearify(n, ind.first - 1, 0);
            clearify(ind.first + 1, m, cur_ans - pr_ans - 1 + ind.second);
        }
    }
}

int solve() {
    cin >> sz >> init;
    cur_ans = init;
    clearify(1, sz, init);
    return 0;
}