#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <set>
#include <map>

#define all(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;
using ld = long double;


template <class T>
void rsort(T& a) {
	sort(all(a), [&](auto b, auto c) { return b > c; });
}


template <class T>
void sort(T& a) {
	sort(all(a));
}


template <class T>
istream& operator>>(istream& in, vector<T>& a)
{
	for (auto& e : a)
	{
		in >> e;
	}
	return in;
}


template <class T1, class T2>
auto max(T1 x1, T2 x2)
{
	if constexpr(sizeof(T1) > sizeof(T2))
	{
		return max(x1, (T1)x2);
	}
	else
	{
		return max((T2)x1, x2);
	}
}


const ll inf = (ll)1e18;

void solve()
{
	vector<ll> a(4);
	cin >> a;

	ll ans = max({
		min(a[0], a[1]) * min(a[2], a[3]),
		min(a[0], a[2])* min(a[1], a[3]),
		min(a[0], a[3])* min(a[2], a[1])
	});
	cout << ans << '\n';
}

signed main()
{
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);

	solve();

	return 0;
}
