#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <set>
#include <map>

#define all(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;
using ld = long double;


template <class T>
void rsort(T& a) {
	sort(all(a), [&](auto b, auto c) { return b > c; });
}


template <class T>
void sort(T& a) {
	sort(all(a));
}


template <class T>
istream& operator>>(istream& in, vector<T>& a)
{
	for (auto& e : a)
	{
		in >> e;
	}
	return in;
}


template <class T1, class T2>
auto max(T1 x1, T2 x2)
{
	if constexpr (sizeof(T1) > sizeof(T2))
	{
		return max(x1, (T1)x2);
	}
	else
	{
		return max((T2)x1, x2);
	}
}


const ll inf = (ll)1e18;

ll phi(ll n)
{
	ll ans = 1;
	for (ll d = 2; d <= n; ++d)
	{
		if (n % d == 0)
		{
			ans *= d - 1;
			while (n % d == 0) {
				ans *= d;
				n /= d;
			}
			ans /= d;
		}
	}
	return ans;
}

void solve()
{
	ll d; cin >> d;

	ll ph = phi(d);

	for (int i = 0; i < d; ++i)
	{
		cout << '1';
		for (int j = 0; j < ph - 1; ++j)
			cout << '0';
	}
	for (int j = 0; j < 9; ++j)
		cout << '0';
}

signed main()
{
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);

	solve();

	return 0;
}
