#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <set>
#include <map>

#define all(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;
using ld = long double;


template <class T>
void rsort(T& a) {
	sort(all(a), [&](auto b, auto c) { return b > c; });
}


template <class T>
void sort(T& a) {
	sort(all(a));
}


template <class T>
istream& operator>>(istream& in, vector<T>& a)
{
	for (auto& e : a)
	{
		in >> e;
	}
	return in;
}


template <class T1, class T2>
auto max(T1 x1, T2 x2)
{
	if constexpr (sizeof(T1) > sizeof(T2))
	{
		return max(x1, (T1)x2);
	}
	else
	{
		return max((T2)x1, x2);
	}
}


const ll inf = (ll)1e18;

#define TESTS

bool connect(ll x, ll y, ll z, ll t) {
	return (x == z) || (y == t) || (z - x == t - y) || (z - x == y - t);
}

void solve()
{
	ll n; cin >> n;
	vector<ll> x(n), y(n);
	for (ll i = 0; i < n; ++i) {
		cin >> x[i] >> y[i];
	}
	bool issimple = true;
	ll a = x[0], b = x[1];
	ll c = a, d = b;
	for (ll i = 1; i < n; ++i) {
		issimple &= connect(a, b, x[i], y[i]);
		if (!issimple) {
			c = x[i];
			d = y[i];
			break;
		}
	}
	if (issimple) {
		cout << "YES\n";
		cout << a << " " << b << "\n";
		return;
	}
	vector<vector<ll>> candidates{ {a,d}, {c,b}, {a + d - b,d}, {a + b + d,d}, {c, b + c - a}, {c, b+a+c} };
	
	if ( ((a + b + c + d) & 1) == 0 ) {
		// (1,1), (1,-1)
		ll da = (c + d - a - b) / 2;
		candidates.push_back({ a + da,b + da });
		// (1,-1), (1,1) 
		ll dc = (a + b - c - d) / 2;
		candidates.push_back({ c + dc,d + dc });
	}



	bool ok = false;
	ll ansx = 0, ansy = 0;
	for (auto& e : candidates) {
		bool good = true;
		for (ll i = 0; i < n; ++i) {
			good &= connect(e[0], e[1], x[i], y[i]);
		}
		if (good) {
			ansx = e[0];
			ansy = e[1];
			ok = true;
			break;
		}
	}

	if (ok) {
		cout << "YES\n";
		cout << ansx << " " << ansy << "\n";
	}
	else {
		swap(a, c);
		swap(b, d);

		vector<vector<ll>> candidates{ {a,d}, {c,b}, {a + d - b,d}, {a + b + d,d}, {c, b + c - a}, {c, b + a + c} };

		if (((a + b + c + d) & 1) == 0) {
			// (1,1), (1,-1)
			ll da = (c + d - a - b) / 2;
			candidates.push_back({ a + da,b + da });
			// (1,-1), (1,1) 
			ll dc = (a + b - c - d) / 2;
			candidates.push_back({ c + dc,d + dc });
		}

		bool ok = false;
		ll ansx = 0, ansy = 0;
		for (auto& e : candidates) {
			bool good = true;
			for (ll i = 0; i < n; ++i) {
				good &= connect(e[0], e[1], x[i], y[i]);
			}
			if (good) {
				ansx = e[0];
				ansy = e[1];
				ok = true;
				break;
			}
		}

		if (ok) {
			cout << "YES\n";
			cout << ansx << " " << ansy << "\n";
		}
		else {
			cout << "NO\n";
		}
	}
}

signed main()
{
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);
	ll t = 1;
#ifdef TESTS
	cin >> t;
#endif // TESTS
	while(t--)
		solve();

	return 0;
}
