#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <set>
#include <map>

#define all(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;
using ld = long double;


template <class T>
void rsort(T& a) {
	sort(all(a), [&](auto b, auto c) { return b > c; });
}


template <class T>
void sort(T& a) {
	sort(all(a));
}


template <class T>
istream& operator>>(istream& in, vector<T>& a)
{
	for (auto& e : a)
	{
		in >> e;
	}
	return in;
}


template <class T1, class T2>
auto max(T1 x1, T2 x2)
{
	if constexpr (sizeof(T1) > sizeof(T2))
	{
		return max(x1, (T1)x2);
	}
	else
	{
		return max((T2)x1, x2);
	}
}


const ll inf = (ll)1e18;

void solve()
{
	ll n, p, m; cin >> n >> p >> m;
	vector<vector<vector<ll>>> dp(n + 1, vector<vector<ll>>(2 * n + 1, vector<ll>(n+1, 0)));
	dp[0][0][0] = 1;

	for (int i = 1; i <= n - p; ++i) {
		for (int j = 0; j <= n; ++j)
			for (int x = 1; x<= i; ++x)
			{
				dp[i][j][x] = 0;
				for (int t = x; t <= i; ++t)
				{
					dp[i][j][x] += dp[i - t][j ^ t][i - t ? t : 0];
					dp[i][j][x] %= m;
				}
			}
	}
	
	ll ans = 0;
	for (int i = 0; i <= n; ++i)
		ans += dp[n - p][p][i];
	
	cout << ans % m  << '\n';
}

signed main()
{
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);

	solve();

	return 0;
}
