#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <set>
#include <map>

#define all(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;
using ld = long double;


template <class T>
void rsort(T& a) {
	sort(all(a), [&](auto b, auto c) { return b > c; });
}


template <class T>
void sort(T& a) {
	sort(all(a));
}


template <class T>
istream& operator>>(istream& in, vector<T>& a)
{
	for (auto& e : a)
	{
		in >> e;
	}
	return in;
}


template <class T1, class T2>
auto max(T1 x1, T2 x2)
{
	if constexpr (sizeof(T1) > sizeof(T2))
	{
		return max(x1, (T1)x2);
	}
	else
	{
		return max((T2)x1, x2);
	}
}


const ll inf = (ll)1e18;

// #define TESTS

ll max_left(vector<ll> a, vector<ll> b)
{
	sort(a);
	sort(b);
	int i = 0, j = 0;
	ll ans = 0;
	while (i < a.size() && j < b.size())
	{
		while (i < a.size() && a[i] < b[j])
		{
			++i;
		}
		if (i < a.size())
		{
			++i;
			++j;
			++ans;
		}
	}
	return ans;
}

void solve()
{
	ll n; cin >> n;
	vector<ll> a(n), b(n);
	cin >> a >> b;

	ll l = n - max_left(b, a);
	ll r = max_left(a, b);
	cout << r - l + 1 << '\n';
	for (int i = l; i <= r; ++i)
	{
		cout << i << " ";
	}
}

signed main()
{
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);
	ll t = 1;
#ifdef TESTS
	cin >> t;
#endif // TESTS
	while (t--)
		solve();

	return 0;
}
