#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <set>
#include <map>

#define all(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;
using ld = long double;


template <class T>
void rsort(T& a) {
	sort(all(a), [&](auto b, auto c) { return b > c; });
}


template <class T>
void sort(T& a) {
	sort(all(a));
}


template <class T>
istream& operator>>(istream& in, vector<T>& a)
{
	for (auto& e : a)
	{
		in >> e;
	}
	return in;
}


template <class T1, class T2>
auto max(T1 x1, T2 x2)
{
	if constexpr (sizeof(T1) > sizeof(T2))
	{
		return max(x1, (T1)x2);
	}
	else
	{
		return max((T2)x1, x2);
	}
}


const ll inf = (ll)1e18;

char to_lower(char x)
{
	if (x >= 'A' && x <= 'Z')
	{
		return x - 'A' + 'a';
	}
	return x;
}

void solve()
{
	string s, f;
	cin >> s >> f;
	
	set<char> vowels = set<char>({'a', 'e', 'i', 'o', 'u', 'y'});

	bool yes = true;
	ll i = 0, j = 0;
	while (i < s.size() || j < f.size())
	{
		if (i < s.size() && j < f.size() && to_lower(s[i]) == to_lower(f[j]))
		{
			++i;
			++j;
		}
		else if (j < f.size() && vowels.count(to_lower(f[j])))
		{
			++j;
		}
		else
		{
			yes = false;
			break;
		}
	}
	if (yes && i == s.size() && j == f.size())
	{
		cout << "Same\n";
	}
	else
	{
		cout << "Different\n";
	}
}

signed main()
{
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);

	solve();

	return 0;
}
