#include <iostream>
#include <vector>
#include <cmath>

#pragma GCC optimize("O2,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,lzcnt,popcnt")

using namespace std;
#define int long long

// dp_same: (n / 2 + 1) * (n / 2 + 1)
// dp_different: (n + 1) * 512 + (n + 1)

int n,p,m;
vector<int> dp_same, dp_different;

int get_dp_same(int x, int max) {
    //cout << x << " " << max << " " << (x * (n / 2 + 1) + max) << " " << ((n / 2 + 1) * (n / 2 + 1)) << endl;
    return dp_same[x * (n / 2 + 1) + max];
}

int get_dp_different(int x, int p, int max) {
    return dp_different[max + p * (n + 1) + x * 512 * (n + 1)];
}

void set_dp_same(int x, int max, int k) {
    dp_same[x * (n / 2 + 1) + max] = k;
}

void set_dp_different(int x, int p, int max, int k) {
    dp_different[max + p * (n + 1) + x * 512 * (n + 1)] = k;
}

int calc_dp_same(int n, int max) {
    if (get_dp_same(n, max) != -1)
        return get_dp_same(n, max);
    int res = 0;
    if (n == 0) res++;
    for (int x = max; x <= n; x++)
        res = (res + calc_dp_same(n - x, x)) % m;
    set_dp_same(n, max, res);
    return res;
}

int calc_dp_different(int n, int p, int max) {
    //cout << n << " " << p << " " << max << endl;
    if (get_dp_different(n, p, max) != -1)
        return get_dp_different(n, p, max);
    int res = 0;
    if (n % 2 == 0 && p == 0)
        res += get_dp_same(n / 2, 1);
    for (int x = max + 1; x <= n; x++)
        res = (res + calc_dp_different(n - x, p ^ x, x)) % m;
    set_dp_different(n, p, max, res);
    return res;
}
    

signed main() {
    ios_base::sync_with_stdio(false);
    std::cin.tie(NULL);
    cin >> n >> p >> m;
    n -= p;
    dp_same.assign((n / 2 + 1) * (n / 2 + 1), -1);
    dp_different.assign((n + 1) * (n + 1) * 512, -1);
    calc_dp_same(n / 2, 1);
    //cout << "finished 1" << endl;
    calc_dp_different(n, p, 0);
    //cout << "finished 2" << endl;
    cout << get_dp_different(n, p, 0) << endl;
}