import java.io.BufferedReader
import java.io.InputStreamReader
import java.io.PrintWriter
import java.lang.StringBuilder
import java.math.BigInteger
import java.util.HashMap
import java.util.Random
import java.util.StringTokenizer
import kotlin.math.max
import kotlin.math.min

fun powTenPhi(d: Long): Long {
    var p = 10L % d
    var cnt = 1L
    while (p % d != 1L) {
        val newp = (p * 10) % d
        if (10L == newp || newp == 0L || p == newp) {
            return -1
        }
        p = newp
        cnt++
    }
    return cnt
}

fun powOf(d: Long, p: Long): Long {
    var cnt = 0L
    var dd = d
    while (dd % p == 0L) {
        dd /= p
    }
    return cnt
}

fun mySolve(ddIn: Long): String {
    var res = StringBuilder("")
    var dd = ddIn
    var d = dd
    var appendZeros = 0L
    while (d % 10L == 0L) {
        d /= 10
        appendZeros++
    }
    while (d % 5L == 0L) {
        d /= 5
        appendZeros++
    }
    while (d % 2L == 0L) {
        d /= 2
        appendZeros++
    }
    if (dd == 1L) {
        return "239"
    }

    var p = powTenPhi(d) - 1
    var need = dd
    while (need > 0) {
        var cur = min(9L, need)
        need -= cur
        res.append(cur)
        for (i in 0 until p) {
            res.append('0')
        }
    }
    if (p < 0) {
        appendZeros = 1000 * (appendZeros + 1)
    }
    for (i in 0 until appendZeros) {
        res.append('0')
    }
    return res.toString()
}

fun checkSolution(d: Long, num: String): Boolean {
    val checkDigs = num.map { (it.code - '0'.code).toLong() }.sum() % d
    if (checkDigs != 0L) {
        return false
    }
    var bigNum = BigInteger(num)
    val zero = 0
    return bigNum.mod(d.toBigInteger()).equals(zero.toBigInteger())
}

fun test() {
    val has = HashSet<Long>()
    val rnd = Random(1488)
    val maxTest = 100L
    while (has.size < maxTest) {
        var nextD = rnd.nextLong(maxTest) + 1
        while (has.contains(nextD)) {
            nextD = rnd.nextLong(maxTest)
        }
        if (!checkSolution(nextD, mySolve(nextD))) {
            out.println(nextD)
            return
        }
    }
}

fun solve() {
//    test()
    val inp = readLong()
    out.println(mySolve(inp))
}

fun main(args: Array<String>) {
    solve()
    out.close()
}

val out = PrintWriter(System.out)
val br = BufferedReader(InputStreamReader(System.`in`))
var tok = StringTokenizer("")

fun read(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine()!!)
    }
    return tok.nextToken()!!
}

fun readLong() = read().toLong()