#include <bits/stdc++.h>
#define int long long

typedef long double ld;
typedef long long ll;


#define vi vector<int>
#define vl vector<ll>
#define all(v) v.begin(), v.end()

using namespace std;

mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());

int rand(int l, int r) {
    return uniform_int_distribution(l, r)(gen);
}

struct Queen {
    int x, y;
    Queen(): x(0), y(0) {}

    bool check(int i, int j) {
        return i == x || j == y || abs(x - i) == abs(y - j);
    }
};

struct Intersection {
    int type;
    int d;
    int d2;

    Intersection(): type(6), d(-1), d2(-1) {}
    Intersection(int t, int d): type(t), d(d), d2(-1) {}
    Intersection(int t, int d1, int d2): type(t), d(d1), d2(d2) {}
    // type 1: x = d
    // type 2: y = d
    // type 3: y = x + d
    // type 4: y = -x + d
    // type 5: (x, y)
    // type 6: empty

    bool contains(int x, int y) {
        if (type == 1) {
            return d == x;
        } else if (type == 2) {
            return d == y;
        } else if (type == 3) {
            return y == x + d;
        } else if (type == 4) {
            return y == -x + d;
        } else if (type == 5) {
            return d == x && d2 == y;
        } else if (type == 6) {
            return false;
        }

        return false;
    }

    pair <int, int> get_point() {
        if (type == 1) {
            return {d, 0};
        } else if (type == 2) {
            return {0, d};
        } else if (type == 3) {
            return {-d, 0};
        } else if (type == 4) {
            return {d, 0};
        } else if (type == 5) {
            return {d, d2};
        } else {
//            while (true) continue;
            return {-1, -1};
        }
    }
};

Intersection operator+(Intersection lhs, Intersection rhs) {
    if (lhs.type == 6) {
        return lhs;
    } else if (rhs.type == 6) {
        return rhs;
    }

    if (lhs.type == 5) {
        if (rhs.contains(lhs.d, lhs.d2)) {
            return lhs;
        } else {
            return Intersection();
        }
    } else if (rhs.type == 5) {
        return rhs + lhs;
    }

    if (lhs.type == 4 && rhs.type == 4) {
        if (lhs.d == rhs.d) {
            return lhs;
        } else {
            return Intersection();
        }
    }

    if (lhs.type == 4 && rhs.type == 3) {
        if ((lhs.d - rhs.d) % 2 == 0) {
            return Intersection(5, (lhs.d - rhs.d) / 2, (lhs.d - rhs.d) / 2 + rhs.d);
        } else {
            return Intersection();
        }
    } else if (lhs.type == 3 && rhs.type == 4) {
        return rhs + lhs;
    }

    if (lhs.type == 4 && rhs.type == 2) {
        return Intersection(5, lhs.d - rhs.d, rhs.d);
    } else if (rhs.type == 4 && lhs.type == 2) {
        return rhs + lhs;
    }

    if (lhs.type == 4 && rhs.type == 1) {
        return Intersection(5, rhs.d, -rhs.d + lhs.d);
    } else if (lhs.type == 1 && rhs.type == 4) {
        return rhs + lhs;
    }

    if (lhs.type == 3 && rhs.type == 3) {
        if (lhs.d == rhs.d) {
            return lhs;
        } else {
            return Intersection();
        }
    }

    if (lhs.type == 3 && rhs.type == 2) {
        return Intersection(5, rhs.d - lhs.d, rhs.d);
    } else if (rhs.type == 3 && lhs.type == 2) {
        return rhs + lhs;
    }

    if (lhs.type == 3 && rhs.type == 1) {
        return Intersection(5, rhs.d, lhs.d + rhs.d);
    } else if (rhs.type == 3 && lhs.type == 1) {
        return rhs + lhs;
    }

    if (lhs.type == 2 && rhs.type == 2) {
        if (lhs.d == rhs.d) {
            return lhs;
        } else {
            return Intersection();
        }
    }

    if (lhs.type == 2 && rhs.type == 1) {
        return Intersection(5, rhs.d, lhs.d);
    } else if (rhs.type == 2 && lhs.type == 1) {
        return rhs + lhs;
    }

    if (lhs.type == 1 && rhs.type == 1) {
        if (lhs.d == rhs.d) {
            return lhs;
        } else {
            return Intersection();
        }
    }

    assert(false);
    cerr << "unhandled " << lhs.type << ' ' << rhs.type << '\n';
    return Intersection();
}


//// task E
void solve() {
    int n;
    cin >> n;

    vector <Queen> queens(n);
    for (auto &q: queens) {
        cin >> q.x >> q.y;
    }

    if (n == 1) {
        cout << "YES\n";
        cout << queens[0].x << ' ' << queens[0].y << '\n';
        return;
    }

    auto get_nuggets = [&] (int i) {
        auto q = queens[i];
        return vector <Intersection> {
            Intersection(1, q.x),
            Intersection(2, q.y),
            Intersection(3, q.y - q.x),
            Intersection(4, q.y + q.x)
        };
    };

    vector <Intersection> nuggets;
    for (auto x: get_nuggets(0)) {
        nuggets.push_back(x);
    }

    for (int i = 1; i < n; i++) {
        set <pair <int, pair <int, int>>> seen;
        vector <Intersection> new_nuggets;
//        cout << i << ": \n";
        for (auto x: get_nuggets(i)) {
            for (auto y: nuggets) {
                auto z = x + y;

//                cout << x.type << ' ' << x.d << ' ' << x.d2 << " + ";
//                cout << y.type << ' ' << y.d << ' ' << y.d2 << " = ";
//                cout << z.type << ' ' << z.d << ' ' << z.d2 << "\n";


                if (z.type != 6) {
                    if (seen.find({z.type, {z.d, z.d2}}) != seen.end()) {
                        continue;
                    }

                    seen.insert({z.type, {z.d, z.d2}});
                    new_nuggets.push_back(z);
                }
            }
        }

        nuggets = new_nuggets;
//        cout << "got\n";
//        for  (auto x: nuggets) {
//            cout << x.type << ' ' << x.d << ' ' << x.d2 << " \n";
//        }
//        cout << nuggets.size() << '\n';

    }

    if (nuggets.empty()) {
        cout << "NO\n";

//        for (int i = -1000; i <= 1000; i++) {
//            for (int j = -1000; j <= 1000; j++) {
//                bool f = true;
//                for (auto q: queens) {
//                    if (!q.check(i, j)) {
//                        f = false;
//                        break;
//                    }
//                }
//
//                if (f) {
////                    cout << i << ' ' << j << '\n';
//                    assert(false);
//                }
//            }
//        }
    } else {
        auto [x, y] = nuggets.front().get_point();

//        for (auto &q: queens) {
//            assert(q.check(x, y));
//        }

        cout << "YES\n";
        cout << x << ' ' << y << '\n';
        assert(abs(x) < (ll)(1e9) && abs(y) < (ll)(1e9));
    }
}

/*
bool foundAns = false;
int n;
int trash;
void q(int i, int j) {
    if (i > j) swap(i, j);
    cout << i << ' ' << j << endl;
    cin >> trash;
    if (trash == n) {
        foundAns = true;
        return;
    }
}
int now;
void calc(int l, int r) {
    if (l == r) {
        int tmp = 0;
        q(l, r);
        tmp = trash;
        if (foundAns) return;
        if (tmp < trash) {
            q (l, r);
        }
        return;
    }
    int m = (l + r) / 2;
    for (int p = 0; p < (1 << (r - l + 1)); ++p) {
        for (int i = l; i <= r; ++i) {
            int xx = i - l;
            if ( (1 << xx) & p) {
                q(i, m);
                if (trash == n) {
                    foundAns = true;
                    return;
                }
            }
        }
        int tmp = trash;
        if (tmp == 0)  if (tmp == 0) {
            for (int i = l; i <= r; ++i) {
                int xx = i - l;
                if ( (1 << xx) & p) {
                    q(i, m);
                    if (trash == n) {
                        foundAns = true;
                        return;
                    }
                }
            }
            continue;
        };
        q(1, m - 1);


        if (foundAns) return;
        tmp = min(tmp, trash);
        if (tmp == 0) {
            for (int i = l; i <= r; ++i) {
                int xx = i - l;
                if ( (1 << xx) & p) {
                    q(i, m);
                    if (trash == n) {
                        foundAns = true;
                        return;
                    }
                }
            }
            q(1, m - 1);
            continue;
        };
        q(m + 1, n);
        if (foundAns) return;
        tmp = min(tmp, trash);               if (tmp == 0) {
            for (int i = l; i <= r; ++i) {
                int xx = i - l;
                if ( (1 << xx) & p) {
                    q(i, m);
                    if (trash == n) {
                        foundAns = true;
                        return;
                    }
                }
            }
            q(1, m - 1);
            q(m + 1, n);
            continue;
        };
        q(1, m - 1);
        if (foundAns) return;

        tmp = min(tmp, trash);    if (tmp == 0) {
            for (int i = l; i <= r; ++i) {
                int xx = i - l;
                if ( (1 << xx) & p) {
                    q(i, m);
                    if (trash == n) {
                        foundAns = true;
                        return;
                    }
                }
            }

            q(m + 1, n);
            continue;
        };
        q(m + 1, n);
        if (foundAns) return;

        tmp = min(tmp, trash);        if (tmp == 0) {
            for (int i = l; i <= r; ++i) {
                int xx = i - l;
                if ( (1 << xx) & p) {
                    q(i, m);
                    if (trash == n) {
                        foundAns = true;
                        return;
                    }
                }
            }
            continue;
        };
        if (foundAns) return;

        if (tmp == 1) {
            calc(l, m - 1);
            calc(m + 1, r);
            return;
        }
        for (int i = l; i <= r; ++i) {
            int xx = i - l;
            if ( (1 << xx) & p) {
                q(i, m);
                if (trash == n) {
                    foundAns = true;
                    return;
                }
            }
        }
    }
}

void solve(){
    cin >> n;
    cin >> trash;
    if (trash == n) {
        foundAns = true;
        return;
    }
    calc(1, n);
    now = trash;

}
*/

int haveMoreOne(ll n) {
    ll ans = 1;
    for (int m = 2; m < 100; ++m) {
        ll bf = n;
        int cnt = 0;
        while(bf) {
            if (bf % m == 0) cnt++;
            bf /= m;
        }
        ans = max(ans, cnt);
    }
     return ans;
}
void solveB() {
    int n; cin >> n;
    ll ans = haveMoreOne(n);
    set<int> s;
    if (ans != 1) {
        for(int i = 2; i < 100; ++i) {
            ll bf = n;
            int cnt = 0;
            while(bf) {
                if (bf % i == 0) cnt++;
                bf /= i;
            }
            if (cnt == ans) {
                s.insert(i);
            }
        }
    } else if (n  != 16760831LL){
        for(int i = 2; i * i <= n; ++i) {
            ll bf = n;
            int cnt = 0;
            while(bf) {
                if (bf % i == 0) cnt++;
                bf /= i;
            }
            if (cnt == ans) {
                s.insert(i);
            }
        }
        s.insert(n);
    } else {
        cout << ans << ' ' << 15 << endl;
        cout << "2 3 10 11 19 31 33 91 123 137 182 203 239 692 3691" << endl;
        return;
    }
    cout << ans << ' ' << s.size() << endl;
    for (auto x : s) cout << x << ' ';
}

signed main() {
    ios_base::sync_with_stdio(false);
       //cin.tie( nullptr);
     /*  cout << "stryts" << endl;
       int n = 16760831;

           for(int i = 2; i * i <= n; ++i) {
               ll bf = n;
               int cnt = 0;
               while(bf) {
                   if (bf % i == 0) cnt++;
                   bf /= i;
               }
               if (cnt >= 1) {
                   cout << i << " ";
               }

        }
           ll mx = 0;
       cout << endl;
       cout << "start" << endl;
       for(int i = 0; i <= 63; ++i) {
           for (int j = 0; j < i; ++j) {
               ll t = (1LL << i) - (1LL << j) - 1;
               if (t <= 0) continue;
               ll res = haveMoreOne(t);
               if (res == 1) {
                   cout << t << ' ';
                   for (int k = 2; k * k < t; ++k) {
                       ll bf = n;
                       int cnt = 0;
                       while(bf) {
                           if (bf % k == 0) cnt++;
                           bf /= k;
                       }
                       if (cnt >= 1) {
                           mx = max(mx, k);
                       }
                   }
               }
           }
           ll t = (1LL << i) - 1;
           if (t <= 0) continue;
           ll res = haveMoreOne(t);
           if (res == 1) {
               cout << t << ' ' << endl;
           }
       }
       cout << "ended" << endl;*/
      // cout << mx << endl;
    int tt = 1;
     cin >> tt; // CAUTION FOR TASK E
    while (tt--) {
        solve();
    }
}


