class Graph:
    def __init__(self, n, colors):
        self.nodes = {i:[] for i in range(2*n)}
        self.visited = {}
        self.color_visited = {}
        self.colors = colors
        
        
    def add_node(self, first, second):
        self.nodes[first-1].append(second-1)
        self.nodes[second-1].append(first-1)
    
    
    def go_through(self):
        for start in self.nodes:
            stack = [start]
            res = [str(start+1)]
            self.visited = {}
            self.color_visited = {}
            self.visited[start] = 1
            self.color_visited[self.colors[start]] = 1
            while len(stack) != 0:
                cur = stack.pop()
                for i in self.nodes[cur]:
                    if not self.visited.get(i, 0) and not self.color_visited.get(self.colors[i], 0):
                        stack.append(i)
                        res.append(str(i+1))
                        self.visited[i] = 1
                        self.color_visited[self.colors[i]] = 1
                        
            if len(res) == n:
                return " ".join(res)
        return -1
    
    
    
t = int(input())
for i in range(t):
    n = int(input())
    colors = [int(j) for j in input().split()]
    g = Graph(n, colors)
    for j in range(2*n-1):
        first, second = [int(i) for i in input().split()]
        g.add_node(first, second)
    print(g.go_through())
    