#include <bits/stdc++.h>

using namespace std;

bool lie(int x1, int y1, int x2, int y2) {
    return x1 == x2 || y1 == y2 || abs(x1 - x2) == abs(y1 - y2);
}

bool all_lie(int xx, int yy, vector<int>& x, vector<int>& y) {
    for (int i = 0; i < x.size(); ++i) {
        if (!lie(x[i], y[i], xx, yy))
            return false;
    }
    return true;
}

bool solve(vector<int> x, vector<int> y) {
    int n = x.size();
    int init_x = -1, init_y = -1;
    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            x[i] -= x[0];
            y[i] -= y[0];
        } else {
            init_x = x[0];
            init_y = y[0];
        }
    }
    x[0] = y[0] = 0;
    vector<pair<int, int>> to_check;
    for (int i = 1; i < n; ++i) {
        if (!lie(x[0], y[0], x[i], y[i])) {
            to_check.emplace_back(0, y[i]);
            to_check.emplace_back(y[i], y[i]);
            to_check.emplace_back(-y[i], y[i]);

            to_check.emplace_back(x[i], 0);
            to_check.emplace_back(x[i], -x[i]);
            to_check.emplace_back(x[i], x[i]);

            to_check.emplace_back(0, x[i] + y[i]);
            to_check.emplace_back(x[i] + y[i], 0);
            if ((y[i] + x[i]) % 2 == 0) {
                to_check.emplace_back((y[i] + x[i]) / 2, (y[i] + x[i]) / 2);
            }

            to_check.emplace_back(0, -x[i] + y[i]);
            to_check.emplace_back(x[i] - y[i], 0);
            if ((x[i] - y[i]) % 2 == 0) {
                to_check.emplace_back((x[i] - y[i]) / 2, (y[i] - x[i]) / 2);
            }

            for (auto [xx, yy] : to_check) {
                if (all_lie(xx, yy, x, y)) {
                    cout << "YES\n";
                    cout << xx + init_x << " " << yy + init_y << "\n";
                    return true;
                }
            }
            cout << "NO\n";
            return false;
        }
    }
    cout << "YES\n";
    cout << init_x << " " << init_y << "\n";

    return true;
}

bool stupid(vector<int> x, vector<int> y) {
    int bord = 50;
    for (int xx = -bord; xx <= bord; ++xx) {
        for (int yy = -bord; yy <= bord; ++yy) {
            if (all_lie(xx, yy, x, y)) {
                cout << xx << " " << yy << "\n";
                return true;
            }
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    for (int T = 0;; ++T) {
//        cout << "TEST: " << T << endl;
//        int n = rand() % 3 + 1;
//        vector<int> x(n), y(n);
//        for (int i = 1; i < n; ++i) {
//            x[i] = rand() % 20 - 10;
//            y[i] = rand() % 20 - 10;
//        }
//        bool s1 = solve(x, y);
//        bool s2 = stupid(x, y);
//        if (s1 != s2) {
//            cout << s1 << " " << s2 << "\n";
//            for (int i = 0; i < n; ++i) {
//                cout << x[i] << " " << y[i] << "\n";
//            }
//            break;
//        }
//    }
    int T; cin >> T;
    while (T--) {
        int n; cin >> n;
        vector<int> x(n), y(n);
        for (int i = 0; i < n; ++i) cin >> x[i] >> y[i];
        solve(x, y);
    }
    return 0;
}