#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define sz(x) ((int)x.size())
#define all(x) (x).begin(), (x).end()
#define add push_back
#define f first
#define s second

const int N = 2e5 + 10;
int arr[N], pair_c[N], sos[N];
vector <int> tr[N];

pair <int, int> find_ones(int n) {
    vector <int> kek;
    for (int i = 0; i < n; i++) {
        if (arr[i] == 0) {
            kek.add(i);
        }
    }
    assert(sz(kek) == 2);
    return make_pair(kek[0], kek[1]);
}

namespace dva_sat {

vector <int> gr[N * 2], rgr[N * 2];
vector <int> order;
bool used[N * 2], ans[N];
int col[N * 2];

void clear(int n) {
    for (int i = 0; i < n * 2; i++) {
        vector <int> ().swap(gr[i]);
        vector <int> ().swap(rgr[i]);
        used[i] = 0; col[i] = 0;
    }
    order.clear();
}

int get_vnum(int v, bool s) {
    return v * 2 + (int)(!s);
}

void add_clause(int u, bool su, int v, bool sv) {
    // cerr << "(";
    if (!su) {
        // cerr << "!";
    }
    // cerr << u + 1 << " v ";
    if (!sv) {
        // cerr << "!";
    }
    // cerr << v + 1 << ")" << endl;

    gr[get_vnum(u, !su)].add(get_vnum(v, sv));
    gr[get_vnum(v, !sv)].add(get_vnum(u, su));

    rgr[get_vnum(v, sv)].add(get_vnum(u, !su));
    rgr[get_vnum(u, su)].add(get_vnum(v, !sv));
}

void topsort(int v) {
    used[v] = 1;
    for (int u : gr[v]) {
        if (!used[u]) {
            topsort(u);
        }
    }
    order.add(v);
}

void dfs(int v, int c) {
    col[v] = c;
    for (int u : rgr[v]) {
        if (!col[u]) {
            dfs(u, c);
        }
    }
}

bool solve(int n) {
    for (int i = 0; i < n * 2; i++) {
        if (!used[i]) {
            topsort(i);
        }
    }
    reverse(all(order));

    int cnt = 0;
    for (int v : order) {
        if (!col[v]) {
            dfs(v, ++cnt);
        }
    }

    for (int i = 0; i < n * 2; i += 2) {
        if (col[i] == col[i + 1]) {
            return 0;
        }

        ans[i / 2] = (col[i] > col[i + 1]);
    }

    return 1;
}

}

void dfs(int v, int p) {
    if (p != -1) {
        dva_sat::add_clause(v, 0, p, 1);
    }
    for (int u : tr[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
}

bool calc_ans_from_v(int v, int n) {
    // cerr << "calcing ans from " << v << endl;

    dva_sat::clear(n);
    dfs(v, -1);

    for (int i = 0; i < n; i++) {
        if (i < pair_c[i]) {
            dva_sat::add_clause(i, 0, pair_c[i], 0);
            dva_sat::add_clause(i, 1, pair_c[i], 1);
        }
    }

    dva_sat::add_clause(v, 1, v, 1);

    return dva_sat::solve(n);
}

void print_ans(int n) {
    for (int i = 0; i < n; i++) {
        if (dva_sat::ans[i]) {
            cout << i + 1 << " ";
        }
    }
    cout << "\n";
}

void solve() {
    int n;
    cin >> n;
    n *= 2;

    for (int i = 0; i < n; i++) {
        sos[i] = -1;
    }

    for (int i = 0; i < n; i++) {
        cin >> arr[i];
        arr[i]--;
        if (sos[arr[i]] != -1) {
            pair_c[i] = sos[arr[i]]; pair_c[sos[arr[i]]] = i;
        }
        sos[arr[i]] = i;

        vector <int> ().swap(tr[i]);
    }

    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        tr[u].add(v); tr[v].add(u);
    }

    auto ones = find_ones(n);

    if (calc_ans_from_v(ones.f, n)) {
        print_ans(n);
        return;
    }

    if (calc_ans_from_v(ones.s, n)) {
        print_ans(n);
        return;
    }

    cout << -1 << "\n";
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int t;
    cin >> t;

    while (t--) {
        solve();
    }
}
