#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;

#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)

template<typename T>
istream& operator>>(istream& in, vector<T>& v)
{
    for (auto& e : v)
    {
        in >> e;
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v)
{
    for (auto& e : v)
    {
        out << e << " ";
    }
    return out;
}

void dfs(int v, int p, vvi& g, vi& c, vi& ind, int B, vvi& deps)
{
    for (auto u : g[v]) if (u != p)
    {
        int xi = 4 * c[u] + 2 * ind[u];
        int yi = 4 * c[v] + 2 * ind[v];
        deps[xi + 1].push_back(yi + 1);
        deps[yi].push_back(xi);
        dfs(u, v, g, c, ind, B, deps);
    }
}

void dfs2(int v, vvi& g, vi& color, int pnt, vi& q)
{
    color[v] = pnt;
    for (auto u : g[v]) if (color[u] == -1)
    {
        dfs2(u, g, color, pnt, q);
    }
    q.push_back(v);
}

void solve()
{
    #define tests

    const int B = 0;

    int n;
    cin >> n;
    vi c(2 * n);
    cin >> c;

    vvi g(2 * n);
    forn(i, 2 * n - 1)
    {
        int f, t;
        cin >> f >> t;
        f--, t--;
        g[f].push_back(t);
        g[t].push_back(f);
    }

    vi pos;
    forn(i, 2 * n) c[i]--;
    vi tiny(2 * n);
    vi cnt(n);
    forn(i, 2 * n) if (c[i] == B) pos.push_back(i);
    forn(i, 2 * n)
    {
        tiny[i] = cnt[c[i]];
        cnt[c[i]]++;
    }

    for (auto root : pos)
    {
        vvi deps(4 * n);
        dfs(root, root, g, c, tiny, B, deps);
        for (int i = 0; i < n; i++)
        {
            deps[4 * i].push_back(4 * i + 3);
            deps[4 * i + 3].push_back(4 * i);
            deps[4 * i + 2].push_back(4 * i + 1);
            deps[4 * i + 1].push_back(4 * i + 2);
        }
        vvi inv_deps(4 * n);
        for (int i = 0; i < 4 * n; i++)
        {
            for (auto u : deps[i])
            {
                inv_deps[u].push_back(i);
            }
        }
        vi color1(4 * n, -1);
        int pnt = 0;
        vi q;
        for (int i = 0; i < 4 * n; i++)
        {
            if (color1[i] == -1)
            {
                dfs2(i, inv_deps, color1, pnt, q);
                pnt++;
            }
        }

        vi q2;
        vi color2(4 * n, -1);
        pnt = 0;
        reverse(q.begin(), q.end());
        for (auto e : q)
        {
            if (color2[e] == -1)
            {
                dfs2(e, deps, color2, pnt, q2);
                pnt++;
            }
        }

        int fail = 0;
        for (int i = 0; i < 2 * n; i++)
        {
            if (color2[2 * i] == color2[2 * i + 1])
            {
                fail = 1;
            }
        }

        if (!fail)
        {
            vi sel(n);
            for (int i = 0; i < 2 * n; i++)
            {
                if (color2[2 * i] > color2[2 * i + 1] && i % 2 == 0)
                {
                    sel[i / 2] = 0;
                }
                if (color2[2 * i] > color2[2 * i + 1] && i % 2 == 1)
                {
                    sel[i / 2] = 1;
                }
            }

            vi ans;
            for (int i = 0; i < 2 * n; i++)
            {
                if (sel[c[i]] == 0)
                {
                    ans.push_back(i + 1);
                }
                sel[c[i]]--;
            }
            sort(ans.begin(), ans.end());
            cout << ans << "\n";
            return;
        }
    }
    cout << -1 << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    #ifdef LOCAL
    cerr << "Ready" << endl;
    #endif

    int t = 1;
    cin >> t;
    while (t--)
    {
        solve();
    }
}