#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <random>
#include <set>

using namespace std;

#define int long long

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;

#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)

template<typename T>
istream& operator>>(istream& in, vector<T>& v)
{
	for (auto& e : v)
	{
		in >> e;
	}
	return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v)
{
	for (auto& e : v)
	{
		out << e << " ";
	}
	return out;
}

const int INF = 1e18;

void solve()
{
#define tests

	int n;
	cin >> n;
	vector<int> x(n), y(n);
	for (int i = 0; i < n; i++)
	{
		cin >> x[i] >> y[i];
	}
	mt19937 vv(79);
	for (int i = 0; i < n; ++i) {
		int v = vv() % (n - i);
		swap(x[i], x[i + v]);
		swap(y[i], y[i + v]);
	}
	int minx = *min_element(x.begin(), x.end());
	int maxx = *max_element(x.begin(), x.end());
	int miny = *min_element(y.begin(), y.end());
	int maxy = *max_element(y.begin(), y.end());

	int minsum = INF, maxsum = -INF;
	int mindif = INF, maxdif = -INF;

	forn(i, n)
	{
		minsum = min(minsum, x[i] + y[i]);
		maxsum = max(maxsum, x[i] + y[i]);
		mindif = min(mindif, x[i] - y[i]);
		maxdif = max(maxdif, x[i] - y[i]);
	}

	if (minx == maxx || miny == maxy || minsum == maxsum || mindif == maxdif)
	{
		cout << "YES\n";
		cout << x[0] << " " << y[0] << "\n";
		return;
	}

	set<int> ids;
	int cntr = 2;
	for (int i = 0; i < n; i++)
	{
		if (x[i] == minx)
		{
			ids.insert(i);
			cntr--;
			if (cntr == 0) break;
		}
	}
	cntr = 2;
	for (int i = 0; i < n; i++)
	{
		if (x[i] == maxx)
		{
			ids.insert(i);
			cntr--;
			if (cntr == 0) break;
		}
	}
	cntr = 2;
	for (int i = 0; i < n; i++)
	{
		if (y[i] == miny)
		{
			ids.insert(i);
			cntr--;
			if (cntr == 0) break;
		}
	}
	cntr = 2;
	for (int i = 0; i < n; i++)
	{
		if (y[i] == maxy)
		{
			ids.insert(i);
			cntr--;
			if (cntr == 0) break;
		}
	}

	for (int i = 0; i < n; i++)
	{
		if (ids.size() < 70)
		{
			ids.insert(i);
		}
	}

	auto check_candidate = [&](int x0, int y0)
	{
		int cnt = 0;
		for (int i = 0; i < n; i++)
		{
			if (x[i] == x0 || y[i] == y0 || abs(x[i] - x0) == abs(y[i] - y0))
			{
				cnt++;
			}
		}
		if (cnt == n) return 1;
		return 0;
	};

	for (auto i_ : ids) for (auto j_ : ids) if (i_ < j_)
	{
		if (x[i_] != x[j_] && y[i_] != y[j_] && abs(x[i_] - x[j_]) != abs(y[i_] - y[j_]))
		{
			int i = 2 * x[i_], j = 2 * y[i_];
			int a = 2 * x[j_], b = 2 * y[j_];
			int fl = 0;
			for (auto pnt : vector<pair<int, int> >{
				{i, b}, {a, j},
				{i, i - a + b}, {a - b + j, j},
				{i, a + b - i}, {a + b - j, j},
				{a, a - i + j}, {a, i + j - a},
				{b + i - j, b}, {i + j - b, b},
				{(i - j + a + b) / 2, (a + b - i + j) / 2}, {(a - b + i + j) / 2, (i + j - a + b) / 2}
				})
			{
				if (pnt.first % 2 == 0 && pnt.second % 2 == 0)
				{
					if (check_candidate(pnt.first / 2, pnt.second / 2))
					{
						cout << "YES\n";
						cout << pnt.first / 2 << " " << pnt.second / 2 << "\n";
						fl = 1;
						return;
					}
				}
			}
			if (fl == 0)
			{
				cout << "NO\n";
				return;
			}
		}
	}

	assert(n <= 70);

	forn(i, n)
	{
		if (check_candidate(x[i], y[i]))
		{
			cout << "YES\n";
			cout << x[i] << " " << y[i] << "\n";
			return;
		}
	}
	cout << "NO\n";
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);

#ifdef LOCAL
	cerr << "Ready" << endl;
#endif

	int t = 1;
	cin >> t;
	while (t--)
	{
		solve();
	}
}