#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;

#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)

template<typename T>
istream& operator>>(istream& in, vector<T>& v)
{
    for (auto& e : v)
    {
        in >> e;
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v)
{
    for (auto& e : v)
    {
        out << e << " ";
    }
    return out;
}

string rec(int i, int j, int len, vector<vector<vector<int> > >& dp, vector<vector<vector<int> > >& restore)
{
    if (len == 1)
    {
        return "SC";
    }
    if (restore[i][j][len] == -1)
    {
        return "S" + rec(i + 1, j, len - 1, dp, restore) + "C";
    }
    int k = restore[i][j][len];
    return rec(i, j, k, dp, restore) + rec(i + k, j + k, len - k, dp, restore);
}

void solve()
{
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    vector<int> b(n);
    cin >> b;

    vector dp(n, vector(n, vector(n + 1, 0)));
    vector restore(n, vector(n, vector(n + 1, 0)));

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
        {
            if (a[i] == b[j])
            {
                dp[i][j][1] = 1;
            }
        }
    }

    for (int len = 2; len <= n; len++)
    {
        for (int i = 0; i + len <= n; i++)
        {
            for (int j = 0; j + len <= n; j++)
            {
                if (a[i] == b[j + len - 1] && dp[i + 1][j][len - 1])
                {
                    dp[i][j][len] = 1;
                    restore[i][j][len] = -1;
                }
                for (int k = 1; k < len; k++)
                {
                    if (dp[i][j][k] && dp[i + k][j + k][len - k])
                    {
                        dp[i][j][len] = 1;
                        restore[i][j][len] = k;
                    }
                }
            }
        }
    }

    if (dp[0][0][n])
    {
        cout << "YES\n";
        string ans = rec(0, 0, n, dp, restore);
        cout << ans << "\n";
    }
    else cout << "NO\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    #ifdef LOCAL
    cerr << "Ready" << endl;
    #endif

    int t = 1;
    while (t--)
    {
        solve();
    }
}