#include <iostream>
#include <vector>
#include <string>
#include <cstdint>
#include <utility>
#include <cmath>

using namespace std;
size_t JIJA = 3 * 10e3;
size_t count_zeroes(size_t n, size_t base) {
    if (n == 0) {
        return 1;
    }

    size_t sum = 0;
    while (n != 0) {
        size_t last_digit = n % base;
        if (last_digit == 0) {
            sum++;
        }
        n /= base;
    }
    return sum;
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    size_t t;
    cin >> t;
    for (auto i = 0; i < t; ++i) {
        size_t n;
        cin >> n;
        size_t ctr{0};
        size_t max{0};
        for (size_t b = 2; b <= JIJA; ++b) {
            size_t cur = count_zeroes(n, b);
            if (cur == max) {
                ctr++;
            } else if (cur > max) {
                max = cur;
                ctr = 1;
            }
        }

        if (max == 1 && n > JIJA) {
            cout << 1 << ' ' << ctr + 1 << endl;
            for (size_t b = 2; b <= JIJA; ++b) {
                if (count_zeroes(n, b) == 1) {
                    cout << b << ' ';
                }
            }
            cout << n << endl;
        } else {
            cout << max << ' ' << ctr << endl;
            for (size_t b = 2; b <= JIJA; ++b) {
                if (count_zeroes(n, b) == max) {
                    cout << b << ' ';
                }
            }
            cout << endl;
        }
    }
    return 0;
}