#include <bits/stdc++.h>

using namespace std;

using ll = long long;

int f(int x, int b) {
	int res = 0;
	while (x > 0) {
		res += !(x % b);
		x /= b;
	}
	return res;
}

mt19937 rng(566);

struct node {
	int sz = 0;
	int prior;
	node* l;
	node* r;
	node* par;

	node() {
		sz = 1;
		prior = rng();
		l = nullptr;
		r = nullptr;
		par = nullptr;
	}
};

int getSz(node* t) {
	if (t == nullptr) {
		return 0;
	}
	return t->sz;
}

void upd(node* t) {
	t->sz = 1 + getSz(t->l) + getSz(t->r);
}

// sz(l) = x
pair<node*, node*> split(node* t, int x) {
	if (t == nullptr) {
		return make_pair(nullptr, nullptr);
	}

	int sz = getSz(t->l) + 1;
	if (x >= sz) {
		auto[l, r] = split(t->r, x - sz);
		t->r = l;
		if (l != nullptr) {
			l->par = t;
		}
		if (r != nullptr) {
			r->par = nullptr;
		}
		assert(r == nullptr || r->par == nullptr);
		upd(t);
		return make_pair(t, r);
	} else {
		auto[l, r] = split(t->l, x);
		t->l = r;
		if (r != nullptr) {
			r->par = t;
		}
		if (l != nullptr) {
			l->par = nullptr;
		}
		assert(l == nullptr || l->par == nullptr);
		upd(t);
		return make_pair(l, t);
	}
}

node* merge(node* l, node* r) {
	if (l == nullptr) {
		return r;
	}
	if (r == nullptr) {
		return l;
	}

	if (l->prior > r->prior) {
		l->r = merge(l->r, r);
		l->r->par = l;
		upd(l);
		return l;
	} else {
		r->l = merge(l, r->l);
		r->l->par = r;
		upd(r);
		return r;
	}
}

int getIndexByNode(node* t) {
	if (t == nullptr) {
		return 0;
	}

	int ans = getSz(t->l);
	while (t->par != nullptr) {
		if (t->par->l == t) {
			t = t->par;
		} else {
			t = t->par;
			ans += getSz(t->l) + 1;
		}
	}

	return ans;
}

/*void dfs(node* root) {
	if (root->l != nullptr) {
		assert(root->l->par == root);
		dfs(root->l);
	}
	cout << getIndexByNode(root) << ' ';
	if (root->r != nullptr) {
		assert(root->r->par == root);
		dfs(root->r);
	}
}*/

void solveTest() {
	int n, m;
	cin >> n >> m;
	vector a(n - 1, vector<int>(m - 1));
	for (int i = 0; i < n - 1; ++i) {
		string s; cin >> s;
		for (int j = 0; j < m - 1; ++j) {
			a[i][j] = s[j] - '0';
		}
	}
	node* root = nullptr;
	vector ans(n, vector<node*>(m));
	auto Set = [&](int i) {
		auto[L, R] = split(root, i);
		node* me = new node();
		root = merge(merge(L, me), R);
		assert(getIndexByNode(me) == i);
		return me;
	};
	auto Get = [&](int i, int j) {
		return getIndexByNode(ans[i][j]);
	};
	auto Determine = [&](vector<pair<int, int>>& order, int x, int y) {
		auto GetVal = [&](int i) {
			return Get(order[i].first, order[i].second);
		};
		pair<int, int> me{x, y};
		int p = 0;
		while (p < 4 && order[p] != me) ++p;
		assert(p < 4 && order[p] == me);
		int val1 = GetVal((p + 1) % 4);
		int val2 = GetVal((p + 2) % 4);
		int val3 = GetVal((p + 3) % 4);
		int meInd;
		if ((val1 < val2 && val2 < val3) || (val2 < val3 && val3 < val1) || (val3 < val1 && val1 < val2)) {
			meInd = val3 + 1;
		} else {
			meInd = val1 + 1;
		}
		// cerr << x << ' ' << y << ' ' << meInd << ' ' << val1 << ' ' << val2 << ' ' << val3 << '\n';
		return meInd;
	};
	// cerr << "before" << endl;
	for (int i = 0; i < m; ++i) {
		// cerr << i << endl;
		ans[0][i] = Set(0);
	}
	// cerr << "after" << endl;
	for (int i = 1; i < n; ++i) {
		ans[i][0] = Set(0);
		for (int j = 1; j < m; ++j) {
			// cerr << "working " << i << ' ' << j << endl;
			int here = a[i - 1][j - 1];
			vector<pair<int, int>> order;
			if (here == 1) {
				order.emplace_back(i, j);
				order.emplace_back(i, j - 1);
				order.emplace_back(i - 1, j);
				order.emplace_back(i - 1, j - 1);
			} else if (here == 2) {
				order.emplace_back(i, j);
				order.emplace_back(i, j - 1);
				order.emplace_back(i - 1, j - 1);
				order.emplace_back(i - 1, j);
			} else {
				order.emplace_back(i, j);
				order.emplace_back(i - 1, j - 1);
				order.emplace_back(i, j - 1);
				order.emplace_back(i - 1, j);
			}
			ans[i][j] = Set(Determine(order, i, j));
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cout << Get(i, j) + 1 << ' ';
		}
		cout << '\n';
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	solveTest();

	/*vector<node*> a;
	a.push_back(new node());
	for (int i = 0; i < 10; ++i) {
		a.push_back(merge(a.back(), new node()));
	}

	for (auto t : a) {
		dfs(t);
		cout << endl;
	}*/
}